/******* Hash Version ist:  0.4.5  gepackt am:  Mit Aug 18 19:09:15 CEST 2004  *********/
/******* Hash Version ist:  0.4.5  gepackt am:  Son Okt 5 18:02:10 CEST 2003  *********/
#ifdef __arrayliste__
#else
#define __arrayliste__

/*
 *
 * Hash - Template Klassen  /  Hash - Template classes
 *
 * Dokumentation: siehe README  / Documentation:  see README
 *
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: GPLL
 *
 */

#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>

// ist die default Gre des Hash Arrays, Primzahl
#ifndef DEFSIZE
#define DEFSIZE  0x1f
#endif


// ist die default Gre der Sub Arrays
#ifndef SUBASIZE
#define SUBASIZE 0x9
#endif


// Damit kann mit if(err) in die Fehlerbehandlung gegangen werden
#define ERROR  1
#define OK     0
#define NOERROR 0
#define GOERROR 1

// meine spezial defines
// my special defines
typedef unsigned long ulong;
typedef unsigned int uint;
typedef unsigned short ushort;
typedef unsigned char uchar;


#ifndef WATCOM
// hier wird der Operator new anstelle von calloc verwendet, zustzlich wird mit memset
// der Datenbereich mit 0 initialisiert
#define USENEW
#endif

//falls nicht USENEW verwendet wird kann man hier whlen ob man die Arrays mit
//calloc erzeugt und mit 0 vordefinieren lsst, oder ob man mit malloc alocciert
//und dann mit memset() auf 0 vorinitialisiert.

#define NOCALLOC

//Nur wenn USENEW nicht definiert wird,
//besagt das bei einem Vergrern des Arrays die gesamte neue Gre erstmal gemalloct
//wird und dann der alte weggeworfen wird, ist NOREALLOC nicht definiert wird der
//alte Speicher mit realloc() erweitert.
//Es hat sich bei den Testprogrammen herausgestellt das realloc() bei groen Speichergren Probleme bereitet.

#define NOREALLOC

//Besagt ob die Daten der keydata mit "delete" mit freigegeben
//werden sollen oder nicht.
typedef enum Freigabe
{
  HNOFREE,
  HFREE
}
freeenum;


// Returnwerte, 1 ist Fehler, damit if(ok) gleich auf Fehler testet
typedef enum ErrorEnum
{
  ISOK,				// ist ok gehe nicht in die Fehler if   
  NOOK,				// ist nicht ok gehe in die Fehler if
  REOK,				// resize aber OK
  KEYNULL,			// key ist 0
  NIXKEY,			// key nicht gefunden

  // vor diese Zeile einfgen
  NULLERROR,			// kein error definiert
  COUNTER			// nicht verwenden nur fr Zhlung
}
errorenum;


// fr den Zugriff auf die einzelnen Teile des Integer
typedef struct
{
  unsigned short lo, hi;
}
_T_ms_t;

typedef union
{
  _T_ms_t s;
  unsigned int i;
}
_U_mu_union;


// Template Klasse fr die Zuordnung Sortkey und Zeiger auf Daten
template < class DATA > class keydatashort
{

public:
  keydatashort ()
  {
    _M_key.i = 0;
    _M_data = (DATA) 0;
  }

  keydatashort (_U_mu_union __key, DATA __data)
  {
    _M_key = __key;
    _M_data = __data;
  }

  keydatashort (int __key, DATA __data)
  {
    _M_key.i = __key;
    _M_data = __data;
  }

  keydatashort (int __key)
  {
    _M_key.i = __key;
    _M_data = (DATA) 0;
  }

  _U_mu_union _M_key;
  DATA _M_data;
};


// diese Funktion setzt die angegebene Zahl auf die nchste
// Primzahl
inline unsigned int
nextprimzahl (unsigned int __size)
{
  unsigned prims[] = {
    0x0000b, 0x0001f, 0x00029, 0x0003d, 0x00047,
    0x00065, 0x000a7, 0x000d3, 0x000e9, 0x00115,
    0x00199, 0x001af, 0x0021d, 0x00233, 0x0025f,
    0x002a1, 0x002e3, 0x002f9, 0x0033b, 0x003a9,
    0x0042d, 0x0050b, 0x00883, 0x00bfb, 0x00db7,
    /*
       0x00e95, 0x01051, 0x0120d, 0x01741, 0x018fd,
       0x019db, 0x01ab9, 0x01d53, 0x01f0f, 0x02287,
       0x02443, 0x026dd, 0x02a55, 0x05e69, 0x089cf,
       0x0927d, 0x0bde3, 0x0c691, 0x148c3, 0x15a1f,
       0x17429, 0x18e33, 0x196e1, 0x1dc51, 0x1f65b */
  };				// 5 x 5 = 25 Primzahlen

  int x;

  // sucht die nchst grere Primzahl
  for (x = 0; x < 25; x++)
    {
      if (prims[x] > __size)
	{
	  return prims[x];
	}
    }

  return prims[24];
}

// Vergleicht 2 Arrays miteinander
// return Wahr wenn die Arrays gleich sind
// sonst falsch
inline bool
memcmp_int (void *__a, void *__b, size_t __s)
{
  register uint s = __s >> 2;
  register uint x = 0;

  //s = __s / sizeof(uint); 
  if (!s)
    {
      for (; x < __s; x++)
	if (((char *) __a)[x] != ((char *) __b)[x])
	  return false;
    }

  // +++ loop over int +++
  for (; x < s; x++)
    if (((int *) __a)[x] != ((int *) __b)[x])
      return false;

  // char position
  //x *= sizeof (uint);
  x <<= 2;

  for (; x < __s; x++)
    if (((char *) __a)[x] != ((char *) __b)[x])
      return false;

  return true;
}


// Vergleicht die Strings "von hinten", bei einigen Fllen kann
// das von Vorteil sein.
// gibt true zurck wenn die Strings gleich sind
// und gibt false zurck wenn die Strings ungleich sind
inline bool
bstrcmp (const char *__a, const char *__b)
{
  register unsigned int x = strlen (__a), y;
  if (strlen (__b) != x)
    return false;
  for (y = x; y; y--)
    if (__a[y] != __b[y])	// Teste von hinten nach vorn
      return false;
  return true;
}

// Eine "echte" Listenklasse, fr den Sonderfall das stndig 
// Element eingefgt werden
template < class DATA > class rlist
{
public:
  // erstes Element nicht einketten
  rlist (DATA __i)
  {
    _M_next = _M_prev = NULL;
    _M_data = __i;
  }

  // an p anketten
  rlist (rlist * __p, DATA __i)
  {
    if (__p)
      {
	_M_next = __p->_M_next;
	__p->_M_next = this;
	_M_prev = __p;
      }
    else
      {
	_M_next = NULL;
      }
    _M_data = __i;
  }

  ~rlist ()
  {
    if (_M_next)
      delete _M_next;
    _M_next = NULL;
  }

  DATA _M_data;			// Public Daten

  // Private Daten lesen
  rlist *getprev ()
  {
    return _M_prev;
  }

  rlist *getnext ()
  {
    return _M_next;
  }

  void setprev (rlist * __p)
  {
    _M_prev = __p;
  }

  void setnext (rlist * __n)
  {
    _M_next = __n;
  }

private:
  rlist * _M_next, *_M_prev;
};


// die Haupt "real" Liste, Klasse rlist ist eine Hilfsklasse fr rliste
template < class DATA > class rliste
{
public:
  // erstes Element nicht einketten
  rliste ()
  {
    _M_letzte = _M_anker = _M_akt = NULL;
  }

  ~rliste ()
  {
    if (_M_anker)
      delete _M_anker;
  }

  // lscht einzelnes Element
  DATA delakt ()
  {
    if (_M_akt->_M_data)
      delete _M_akt->_M_data;
    umhaengen ();
    return _M_akt ? _M_akt->_M_data : NULL;
  }

  DATA delaktarray ()
  {
    if (_M_akt->_M_data)
      delete[]_M_akt->_M_data;
    umhaengen ();
    return _M_akt ? _M_akt->_M_data : NULL;
  }

  // lscht einzelnes Element ohne die Daten freizugeben
  void destroy ()
  {
    // if (akt->data) delete akt->data;
    umhaengen ();
  }

  // gibt die ganze Liste frei, aber NICHT  die Daten
  void destroyall ()
  {
    rlist < DATA > *x;
    for (x = _M_anker; x; x = x->getnext ())
      {
	x->_M_data = NULL;
      }
    //cerr << "\ndelete anker!\n";
    delete _M_anker;
    _M_akt = _M_letzte = _M_anker = NULL;
  }

  // lscht alle Elemente
  void delall ()
  {
    rlist < DATA > *x;
    for (x = _M_anker; x; x = x->getnext ())
      {
	if (x->_M_data)
	  {
	    delete x->_M_data;
	    x->_M_data = NULL;
	  }
      }
    delete _M_anker;
    _M_akt = _M_letzte = _M_anker = NULL;
  }

  void delallarray ()
  {
    rlist < DATA > *x;
    for (x = _M_anker; x; x = x->getnext ())
      {
	if (x->_M_data)
	  delete[]x->_M_data;
	x->_M_data = NULL;
      }
    delete _M_anker;
    _M_akt = _M_letzte = _M_anker = NULL;
  }

  // setzt aktuelles Listenelement, akt wird auf nchstes Listenelement gesetzt
  errorenum insert (DATA __i)
  {
    if (_M_akt)
      {
	if (_M_akt == _M_letzte)
	  {
	    _M_letzte = _M_akt = new rlist < DATA > (_M_akt, __i);
	    if (_M_letzte && _M_akt)
	      return ISOK;
	  }
	else
	  {
	    _M_akt = new rlist < DATA > (_M_akt, __i);
	    if (_M_akt)
	      return ISOK;
	  }
      }
    else
      {
	// erstes mal
	_M_anker = _M_akt = _M_letzte = new rlist < DATA > (__i);
	if (_M_akt)
	  return ISOK;
      }
    return NOOK;
  }

  errorenum insertlast (DATA __i)	// setze letztes Listenelement, beim 1. mal halt Stelle 0
  {
    if (_M_letzte)
      {
	_M_letzte = new rlist < DATA > (_M_letzte, __i);
	_M_akt = _M_letzte;
	if (_M_letzte)
	  return ISOK;
      }
    else
      {
	// erstes mal
	_M_letzte = _M_anker = _M_akt = new rlist < DATA > (__i);
	if (_M_akt)
	  return ISOK;
      }
    return NOOK;
  }


  DATA getfirst ()		// hole erstes Listenelement, und setzt Zeiger auf erstes
  {
    _M_akt = _M_anker;
    return _M_akt ? _M_akt->_M_data : NULL;
  }

  DATA getlast ()		// holt letztes eingefgte Listenelement
  {
    _M_akt = _M_letzte;
    return _M_akt ? _M_akt->_M_data : NULL;
  }

  DATA getringnext ()		// holt nchstes Listenelement, am Ende beginnt alles wieder von vorn
  {
    _M_akt = _M_akt->getnext ();
    return _M_akt ? _M_akt->_M_data : getfirst ();
  }

  DATA getnext ()		// holt nchstes Listenelement, am Ende return NULL
  {
    if (_M_akt)
      _M_akt = _M_akt->getnext ();
    else
      return NULL;

    return _M_akt ? _M_akt->_M_data : NULL;
  }

  DATA getringprev ()		// holt voriges Listenelement, am Anfang beginnt alles wieder am Ende
  {
    _M_akt = _M_akt->getprev ();
    return _M_akt ? _M_akt->_M_data : getlast ();
  }

  DATA getprev ()		// holt voriges Listenelement, am Anfang return NULL
  {
    if (_M_akt)
      _M_akt = _M_akt->getprev ();
    else
      return NULL;

    return _M_akt ? _M_akt->_M_data : NULL;
  }

  bool isakt ()
  {
    return _M_akt ? true : false;
  }

  bool isnext ()
  {
    return (_M_akt->getnext ())? true : false;
  }

  bool isprev ()
  {
    return (_M_akt->getprev ())? true : false;
  }


protected:

  rlist < DATA > *getakt ()
  {
    return _M_akt;
  }

protected:
  rlist < DATA > *_M_anker, *_M_akt, *_M_letzte;

private:
  // gelschtes ausklinken
  void umhaengen ()
  {
    rlist < DATA > *v, *n;

    v = _M_akt->getprev ();
    n = _M_akt->getnext ();

    if (v)
      v->setnext (n);
    else
      _M_anker = n;		// kein Vorgnger, anker ist 2. Element

    if (n)
      n->setprev (v);
    else
      _M_letzte = v;		// kein Nachfolger, letzte wird vorletztes

    _M_akt->setnext (NULL);	// damit Kette nicht reit!
    delete _M_akt;		// Listenelement freigeben!

    // Aktuelle ist je nach anzahl 2. letztes oder nchstes
    if (!v)
      _M_akt = _M_anker;
    else if (!n)
      _M_akt = _M_letzte;
    else
      _M_akt = n;
  }

};


// Stringerrorfunktion, sollte eigentlich in ein Objektfile kommen,
// naja einmal kann man schon eine Ausnahme machen, tja jetzt wird es halt
// eine Klasse die irgendwo eine Instanz haben muss
class laperror
{

public:
  laperror ()
  {
    char x = 0;
      _M_addstr = "!\n";
      _M_errstr[x++] = "Alles OK";
      _M_errstr[x++] = "Allgemeiner Fehler";
      _M_errstr[x++] = "Resize, alles OK";
      _M_errstr[x++] = "Key war 0, Ist fr Interne Zwecke reserviert";
      _M_errstr[x++] =
      "Nix gefunden, Mitglied ist vermutlich schon gelscht gewesen";
    // Einfgungen bitte vor diese zeile einfgen!    
      _M_errstr[x++] = "dummy, kein Error definiert";
      _M_errstr[x++] = "Counter, da ist die Fehlernummer falsch";
  }

   ~laperror ()
  {
  }

  void str (errorenum __e, char *__userstr)
  {
    if (__e == ISOK)
      return;

    if (__e <= COUNTER)
      {
	if (__userstr)
	  {
	    cerr << _M_errstr[(int) __e] << " " << __userstr << _M_addstr;
	  }
	else
	  cerr << _M_errstr[(int) __e] << _M_addstr;
      }
    else
      cerr <<
	"Fehlerfunktion laperror, mit nicht definierten Fehler " <<
	(int) __e << " aufgerufen" << _M_addstr;
  }

private:
  char *_M_addstr;
  char *_M_errstr[6];
};

// Etwas schreibfaul kann man schon sein
#define unsigned unsigned int


// ********************************
// Klasse fr das Key / Data Paar
// Die nachfolgende Klasse qsort, hat diese Klasse als 
// Member so das nach "key" sortiert werden kann
// Key sollte sinnvollerweise eine ganze Zahl sein.
// also int, char, long, oder short
template < class DATA, class KEY > class keydata
{
public:
  keydata ()
  {
  }

  keydata (KEY __k, DATA __d)
  {
    _M_key = __k;
    _M_data = __d;
  }

  ~keydata ()
  {
    if (_M_data)
      delete _M_data;		// tja, falls Zeiger!
  }

  KEY _M_key;
  DATA _M_data;
};


// DATA ist der Datentype des Arrays welches sortiert werden soll
// qsort  Zeitbedarf: f(n) = n exp 2
template < class DATA, class KEY > class hqsort
{
public:
  hqsort ()
  {
  }

  ~hqsort ()
  {
  }

  void qsort (keydata < DATA, KEY > **__A, KEY __l)
  {
    hfqsort (__A, (KEY) 0, (KEY) __l);	// Array Grenzen 
  }

  void hfqsort (keydata < DATA, KEY > **__A, KEY __v, KEY __b)
  {
    KEY __q;
    if (__v < __b)
      {
	__q = qpart (__A, __v, __b);
	hfqsort (__A, __v, __q);
	hfqsort (__A, __q + 1, __b);
      }
  }

  KEY qpart (keydata < DATA, KEY > **__A, KEY __v, KEY __b)
  {
    KEY x, i, j;
    keydata < DATA, KEY > *y;

    x = __A[__v]->_M_key;
    i = __v - 1;
    j = __b + 1;

    while (1)
      {
	do
	  j--;
	while (!(__A[j]->_M_key <= x));
	do
	  i++;
	while (!(__A[i]->_M_key >= x));
	// Sortorder kann nicht gendert werden da sonst die Suchfunktion nicht geht
	if (i < j)
	  {
	    y = __A[i];
	    __A[i] = __A[j];
	    __A[j] = y;

	    /*A[i] ^= A[j];
	       A[j] ^= A[i];
	       A[i] ^= A[j]; */
	  }
	else
	  {
	    return j;
	  }
      }
  }
};


// Klasse Array
//
// speichet linear alles Zeiger im Speicher, falls die Arraygre zu klein
// angesetzt war wird das Array vergrert.

template < class DATA > class harray
{
public:

  harray ()
  {
#ifdef USENEW
    _M_a = new DATA[DEFSIZE];
    memset (_M_a, 0, sizeof (DATA) * DEFSIZE);
#else

#ifdef NOCALLOC
    _M_a = (DATA *) malloc (DEFSIZE * sizeof (DATA));
    memset (_M_a, 0, sizeof (DATA) * DEFSIZE);
#else
    _M_a = (DATA *) calloc (DEFSIZE, sizeof (DATA));
#endif

#endif
    _M_size = DEFSIZE;
  }

  harray (unsigned x)
  {
#ifdef USENEW
    _M_a = new DATA[x];
    memset (_M_a, 0, sizeof (DATA) * x);
#else

#ifdef NOCALLOC
    _M_a = (DATA *) malloc (sizeof (DATA) * x);
    memset (_M_a, 0, sizeof (DATA) * x);
#else
    _M_a = (DATA *) calloc (x, sizeof (DATA));
#endif

#endif
    _M_size = x;
  }

  ~harray ()
  {
#ifdef USENEW
    delete[]_M_a;
#else
    free (_M_a);
#endif
  }

  // kopiert __input in das Array, input mu gro genug sein!
  void hafuell (DATA * __input)
  {
    memmove (_M_a, __input, sizeof (DATA) * _M_size);
  }

  DATA haget (unsigned x)	// liet Element
  {
    return _M_a[x];
  }

  errorenum haset (unsigned x, DATA p)	// setzt Element
  {
    if (x < _M_size)
      {
	_M_a[x] = p;
	return ISOK;
      }
    else
      {
	if (expand ())
	  return NOOK;
	_M_a[x] = p;
      }
    return ISOK;
  }

  // fast set
  void hafset (unsigned x, DATA p)	// setzt Element
  {
    _M_a[x] = p;
  }

  void delall (unsigned anz)
  {
    if (anz > _M_size)
      anz = _M_size;
    for (unsigned x = 0; x < anz; x++)
      {
	if (_M_a[x])
	  delete _M_a[x];
      }
    memset (_M_a, 0, sizeof (DATA) * anz);
  }

  // setzt alle Zeiger auf NULL, keine Daten werden freigegeben
  void destroyall ()
  {
    memset (_M_a, 0, sizeof (DATA) * _M_size);
  }

  void delall ()
  {
    for (unsigned x = 0; x < _M_size; x++)
      {
	if (_M_a[x])
	  delete _M_a[x];
      }
    memset (_M_a, 0, sizeof (DATA) * _M_size);
  }


  void delallarray (unsigned anz)
  {
    if (anz > _M_size)
      anz = _M_size;
    for (long x = 0; x < anz; x++)
      {
	if (_M_a[x])
	  delete[]_M_a[x];
      }
    memset (_M_a, 0, sizeof (DATA) * anz);
  }

  void delallarray ()
  {
    for (long x = 0; x < _M_size; x++)
      {
	if (_M_a[x])
	  delete[]_M_a[x];
      }
    memset (_M_a, 0, sizeof (DATA) * _M_size);
  }

protected:


  unsigned hapack (unsigned max)	// Packt das Array zusammen, diese Funktion sollte sehr 
    // sparsam verwendet werden
  {
    unsigned x, cnt, y, anz;

    for (cnt = x = 0; x < max; x++)
      {
	if (!_M_a[x])
	  {
	    cnt++;
	    anz = max - x - 1;
	    // spart memmove's bei greren Lcken
	    for (y = x + 1; (y < max) && (!_M_a[y]); y++, anz--);
	    memmove (_M_a + x, _M_a + y, sizeof (DATA) * anz);
	  }
      }
    return cnt;
  }

  // Array aufspreizen um Platz fr Einfgungen zu schaffen
  unsigned haexpand (unsigned pos, unsigned anz, unsigned max)
  {
    if ((max - pos) > _M_size)
      {
	expand ();
      }

    memmove (_M_a + pos + anz, _M_a + pos, sizeof (DATA) * (max - pos));
    memset (_M_a + pos, 0, sizeof (DATA) * anz);
    return anz;
  }

  unsigned getsize ()
  {
    return _M_size;
  }

  DATA *_M_a;			// Array of Pointers

private:

  // vergrert das Array bei Bedarf
  errorenum expand ()
  {
    DATA *b;
    unsigned ts, oldsize = _M_size;

    _M_size += DEFSIZE;

    if ((ts = nextprimzahl (_M_size)) > _M_size)
      _M_size = ts;
    // else, bleibt halt _M_size+=DEFSIZE ist dann eben keine
    // Primzahl, besser als bis zur nchsten Primzahl zu
    // zhlen

#ifdef USENEW
    if ((b = new DATA[_M_size]))
      {
	memmove (b, _M_a, sizeof (DATA) * oldsize);
	delete[]_M_a;
	_M_a = b;
	return ISOK;
      }
    return NOOK;

#else

#ifdef NOREALLOC
    if ((b = (DATA *) malloc (sizeof (DATA) * _M_size)))
      {
	memmove (b, _M_a, sizeof (DATA) * oldsize);
	free (_M_a);
	_M_a = b;
	return ISOK;
      }
    return NOOK;
#else
    _M_a = (DATA *) realloc (_M_a, sizeof (DATA) * _M_size);
    if (_M_a)
      {
	memset ((_M_a + oldsize), 0, sizeof (DATA) * oldsize / 2);
	return ISOK;
      }
    else
      return NOOK;
#endif
#endif

  }

  unsigned _M_size;
};


// Listenarray,
//
// Kapselfunktionen um mit dem Array wie mit einer Liste umgehen zu knnen
// hier fehlen noch die Funktionen zum Einfgen oder zum lschen von Listenelementen
// sonst ist die Liste als einfach und/oder doppelt verkettete Liste zu betrachten.
// Zustzlich kann hnlich eines Ringpuffers endlos vor oder zurck gelaufen werden
template < class DATA > class larray:public harray < DATA >
{
public:
  larray (unsigned __x):harray < DATA > (__x)
  {
    _M_maxset = _M_akt = 0;
    _M_firstinsert = 1;
  }

larray ():harray < DATA > ()
  {
    _M_maxset = _M_akt = 0;
    _M_firstinsert = 1;
  }

  ~larray ()
  {
  }

  // lscht alle Objekte fr die es Zeiger im Array gibt,    
  // setzt akt auf 0 so das mit "insert" wieder neue daten geschrieben werden knnen
  void delall ()
  {
    harray < DATA >::delall (_M_maxset + 1);	// anzahl nicht max Index
    _M_maxset = _M_akt = 0;
    _M_firstinsert = 1;
  }

  // alle zeiger auf Daten Nullen, nix freigeben
  void destroyall ()
  {
    harray < DATA >::destroyall ();	// alle Elemente Nullen
    _M_maxset = _M_akt = 0;
    _M_firstinsert = 1;
  }

  void delallarray ()
  {
    harray < DATA >::delallarray (_M_maxset + 1);	// anzahl nicht max Index
    _M_maxset = _M_akt = 0;
    _M_firstinsert = 1;
  }

  errorenum insert (DATA __i)
    // setzt aktuelles Listenelement, akt wird auf nchstes Listenelement gesetzt
  {
    if (haset (_M_akt, __i))
      {
	return NOOK;
      }

    if (_M_maxset < _M_akt)
      _M_maxset = _M_akt;
    _M_akt++;

    _M_firstinsert = 0;
    return ISOK;
  }

  // fast Funktion, nur fr Spezialflle, sollte nicht verwendet werden
  void fastinsert (DATA __i)
  {
    hafset (_M_akt++, __i);
    //_M_maxset = _M_akt;
  }

  errorenum insertakt (DATA __i)
  {
    return haset (_M_akt++, __i);
  }

  errorenum insertlast (DATA __i)	// setze letztes Listenelement, beim 1. mal halt Stelle 0
  {
    if (_M_firstinsert)
      {
	_M_firstinsert = 0;
	return haset (_M_akt++, __i);
      }
    else
      {
	_M_akt = ++_M_maxset;
	return haset (_M_akt, __i);
      }
  }

  DATA getfirst ()		// hole erstes Listenelement, und setzt Zeiger auf erstes
  {
    _M_akt = 0;
    return haget (_M_akt);
  }

  DATA getlast ()		// holt letztes eingefgte Listenelement
  {
    _M_akt = _M_maxset;
    return haget (_M_akt);
  }

  DATA getringnext ()		// holt nchstes Listenelement, am Ende beginnt alles wieder von vorn
  {
    if (_M_akt + 1 <= _M_maxset)
      return haget (++_M_akt);
    else
      {
	_M_akt = 0;
	return haget (_M_akt);
      }
  }

  bool getnext (DATA * r)	// holt nchstes Listenelement, am Ende return false
  {
    if ((_M_akt + 1) <= _M_maxset)
      {
	*r = haget (++_M_akt);
	return true;
      }
    else
      {
	return false;
      }
  }

  bool getnext (DATA & r)	// holt nchstes Listenelement, am Ende return false
  {
    if ((_M_akt + 1) <= _M_maxset)
      {
	r = haget (++_M_akt);
	return true;
      }
    else
      {
	return false;
      }
  }

  DATA getringprev ()		// holt voriges Listenelement, am Anfang beginnt alles wieder am Ende
  {
    if ((long) (_M_akt - 1) >= 0)
      return haget (--_M_akt);
    else
      {
	_M_akt = _M_maxset;
	return haget (_M_akt);
      }
  }

  bool getprev (DATA * r)	// holt voriges Listenelement, am Anfang return false
  {
    if ((long) (_M_akt - 1) >= 0)
      {
	*r = haget (--_M_akt);
	return true;
      }
    else
      return false;
  }

  bool getprev (DATA & r)	// holt voriges Listenelement, am Anfang return false
  {
    if ((long) (_M_akt - 1) >= 0)
      {
	r = haget (--_M_akt);
	return true;
      }
    else
      return false;
  }


  void setselektor (unsigned __x)
  {
    _M_akt = __x;
  }

  // setzt den Zeiger
  DATA getselektor (unsigned __x)
  {
    return haget (__x);
  }

  // holt daten am Index x und setzt Index 
  errorenum delselektor (unsigned __x)
  {
    _M_akt = __x;
    return haset (_M_akt, NULL);
  };				// lscht Listenelement durch NULLen

  void pack ()
  {
    _M_maxset -= hapack (_M_maxset);
  }

  void expand (unsigned __pos, unsigned __anz)	// auch unbedingt noch testen !!!
  {
    _M_maxset += haexpand (__pos, __anz, _M_maxset + 1);	// +1 da maxset maximales Arrayindex ist !
    _M_akt = __pos;
  }

  bool isnext ()
  {
    return ((_M_akt + 1) <= _M_maxset) ? true : false;
  }

  /*  Unsinn immer Wahr!!!
     bool isakt ()
     {
     if (_M_firstinsert)
     return false;

     return (!_M_akt) ? true : isnext ();
     }
   */

  bool isprev ()
  {
    return (_M_akt > 0) ? true : false;
  }

  unsigned getanz ()
  {
    return _M_maxset + 1;	// da es die Anzahl werden soll.
  }

protected:
  DATA getlastrm ()		// holt letztes eingefgte Listenelement
  {
    _M_akt = _M_maxset;
    if (_M_maxset > 0)
      _M_maxset--;
    return haget (_M_akt);
  }

  unsigned _M_maxset, _M_firstinsert;

private:
  unsigned _M_akt;
};



// Eine Hash die auf rliste aufbaut, und den Nachteil der Speicherallocierung nicht
// hat. Dafr ist aber die Suche etwas aufwendiger. Hash hat ein Array zum Einstieg, dann 
// werden die Daten auf RListen aufgeteilt.
//template < class DATA, class KEY > class keydata

template < class DATA > class rlistesm:
public rliste < DATA >
{
public:
rlistesm ():rliste < DATA > ()
  {
  }

  // berlade destroy, damit die keydata mit freigegeben werden
  void destroyall ()
  {
    rlist < DATA > *x;

    for (x = _M_anker; x; x = x->getnext ())
      {
	// damit keydata die Daten nicht lscht                   
	x->_M_data->_M_data = NULL;
	// lsche das keydata Objekt
	delete x->_M_data;
      }
    delete _M_anker;
    _M_akt = _M_letzte = _M_anker = NULL;
  }
};

// Listen Hilfsklasse fr die Hash
template < class DATA > class smliste:
public rlistesm < keydata < DATA, unsigned >*>
{
public:

  smliste ():rlistesm < keydata < DATA, unsigned >*>()
  {
    _M_letzte = NULL;
    _M_lkey = 0;
  }

   ~smliste ()
  {
    destroyall ();
  }

  // Einfgefunktion
  errorenum insert (unsigned __key, DATA __i)
  {
    keydata < DATA, unsigned >*kd =
      new keydata < DATA, unsigned >(__key, __i);

    return insertlast (kd);
  }

  // durchsucht alle Listenelemente 
  void search (DATA * __data, unsigned __key, errorenum * __error)
  {
    keydata < DATA, unsigned >*y;

    for (y = getfirst (); isakt (); y = getnext ())
      {
	if (y->_M_key == __key)
	  {
	    *__data = y->_M_data;
	    *__error = ISOK;
	    _M_letzte = y;
	    _M_lkey = __key;
	    return;
	  }
      }

    *__error = NIXKEY;
  }

  // falls doppelt eingefgt wurde kann man mit dieser Funktion 
  // die doppelten finden
  bool searchdoppel (DATA * __data, errorenum * __error)
  {
    // finde nchstes
    for (_M_letzte = getnext (); isakt (); _M_letzte = getnext ())
      {
	if (_M_letzte->_M_key == _M_lkey)
	  {
	    *__data = _M_letzte->_M_data;
	    *__error = ISOK;
	    //letzte = y;
	    return true;	// in Schleife weitermachen
	  }
      }

    *__error = NIXKEY;
    return false;
  }


  // durchsucht alle Listenelemente 
  errorenum update (DATA __data, unsigned __key)
  {
    keydata < DATA, unsigned >*y;

    for (y = getfirst (); isakt (); y = getnext ())
      {
	if (y->_M_key == __key)
	  {
	    y->_M_data = __data;
	    return ISOK;
	  }
      }

    // nix gefunden, dann einfgen
    return insert (__key, __data);
  }

  // gibt Listenelement frei ohne dessen Daten freizugeben
  errorenum destroy (unsigned __key)
  {
    keydata < DATA, unsigned >*y;

    for (y = getfirst (); isakt (); y = getnext ())
      {
	if (y->_M_key == __key)
	  {
	    rlistesm < keydata < DATA, unsigned >*>::destroy ();
	    return ISOK;
	  }
      }
    return NOOK;
  }

  // gibt Listenelement frei ohne dessen Daten freizugeben
  errorenum delakt (unsigned __key)
  {
    keydata < DATA, unsigned >*y;

    for (y = getfirst (); isakt (); y = getnext ())
      {
	if (y->_M_key == __key)
	  {
	    rlistesm < keydata < DATA, unsigned >*>::delakt ();
	    return ISOK;
	  }
      }
    return NOOK;
  }

  // gibt Listenelement frei ohne dessen Daten freizugeben
  errorenum delaktarray (unsigned __key)
  {
    keydata < DATA, unsigned >*y;

    for (y = getfirst (); isakt (); y = getnext ())
      {
	if (y->_M_key == __key)
	  {
	    rlistesm < keydata < DATA, unsigned >*>::delaktarray ();
	    return ISOK;
	  }
      }
    return NOOK;
  }


private:

  keydata < DATA, unsigned >*_M_letzte;
  unsigned _M_lkey;

};


// **************** die Hash selbst ***************************************************
template < unsigned SIZE,
  class DATA > class smhash:public harray < smliste < DATA > *>
{
public:
  smhash ():harray < smliste < DATA > *>(_M_size = nextprimzahl (SIZE))
  {
    _M_rl = NULL;
    //_M_aktlist = 0;
  }

  // lscht keine Daten
   ~smhash ()
  {
    unsigned x;
    smliste < DATA > *p;

    for (x = 0; x < _M_size; x++)
      {
	if ((p = haget (x)))
	  {
	    delete p;
	  }
      }
  }

  // setzt alle daten auf NULL und gibt Speicher frei
  void delall ()
  {
    unsigned x;
    smliste < DATA > *p;

    for (x = 0; x < _M_size; x++)
      {
	if ((p = haget (x)))
	  {
	    p->delall ();
	  }
      }
  }

  // setzt alle daten[] auf NULL und gibt Speicher frei
  void delallarray ()
  {
    int x;
    smliste < DATA > *p;

    for (x = 0; x < _M_size; x++)
      {
	if ((p = haget (x)))
	  {
	    p->delallarray ();
	  }
      }
  }

  // setzt alle daten auf NULL und gibt Speicher NICHT frei!
  void destroyall ()
  {
    unsigned x;
    smliste < DATA > *p;

    for (x = 0; x < _M_size; x++)
      {
	if ((p = haget (x)))
	  {
	    p->destroyall ();
	  }
      }
  }

  // Initialisiert leeren Pointer und Fgt neue Liste ein, prft nicht ob der
  // Schlssel eindeutig ist, bei doppelten Aufrufen wird der Schlssel doppelt
  // eingefgt!
  errorenum insert (unsigned __key, DATA __data)
  {
    unsigned mod = __key % _M_size;
    // hole Listenpointer 
    smliste < DATA > *p = haget (mod);

    if (!p)
      {
	// Liste existiert schon
	p = new smliste < DATA > ();
	if (!p)
	  {
	    cerr << "kann kein new hliste machen!\n";
	    return NOOK;
	  }

	// Liste eintragen nicht vergessen!
	if (haset (mod, p))
	  {
	    return NOOK;
	  }
      }

    p->insert (__key, __data);
    return ISOK;
  }

  // Initialisiert leeren Pointer und Fgt neue Liste ein, prft! ob der
  // Schlssel eindeutig ist, falls der Schlssel schon vorhanden ist dann
  // wird NOOK zurckgegeben
  errorenum insertuni (unsigned __key, DATA __data)
  {
    errorenum error;
    DATA dummy;

    search (&dummy, __key, &error);

    if (error == NIXKEY)
      {
	// nicht gefunden ist hier OK
	return insert (__key, __data);
      }
    else
      {
	return NIXKEY;
      }
  }

  // Initialisiert leeren Pointer und Fgt neue Liste ein, prft! ob der
  // Schlssel eindeutig ist, wenn nicht werden die Daten des alten Schlssels
  // berschrieben
  errorenum update (unsigned __key, DATA __data)
  {
    unsigned mod = __key % _M_size;

    // hole Listenzeiger
    smliste < DATA > *p = haget (mod);
    if (p)
      {
	return p->update (__data, __key);
      }
    else
      {
	// sogar neue Liste !     
	return insert (__key, __data);
	//return NIXKEY;
      }
  }

  // Gibt die Daten die zum key gehren zurck, in error steht ob der
  // Key gefunden wurde oder nicht
  void search (DATA * __data, unsigned __key, errorenum * __error)
  {
    // hole Listenzeiger
    smliste < DATA > *p = _M_rl = haget (__key % _M_size);

    if (p)
      p->search (__data, __key, __error);
    else
      *__error = NIXKEY;
  }

  // Gibt die Daten die zum key gehren zurck, in error steht ob der
  // Key gefunden wurde oder nicht
  bool searchdoppel (DATA * __data, errorenum * __error)
  {
    if (_M_rl)
      return _M_rl->searchdoppel (__data, __error);
    else
      {
	*__error = NIXKEY;
	return false;
      }
  }

  // Lscht den Member key, es wird der Speicher auf den "data" zeigt mit einem
  // delete wenn del auf HFREE stand. Der Speicher fr die Hash oder die SortListe
  // wird nicht freigegeben, sondern nur mit 0 markiert, so das spter dort ein neuer
  // Member gespeichert werden kann. Ist del HNOFREE wird nur 0 markiert und nichts
  // freigegeben.
  errorenum destroy (unsigned __key, freeenum __del)
  {
    smliste < DATA > *p = haget (__key % _M_size);

    if (p)
      {
	if (__del == HFREE)
	  {
	    return p->delakt (__key);
	  }
	else
	  {
	    return p->destroy (__key);
	  }
      }
    else
      return NIXKEY;
  }

  errorenum destroyarray (unsigned __key, freeenum __del)
  {
    smliste < DATA > *p = haget (__key % _M_size);

    if (p)
      {
	if (__del == HFREE)
	  {
	    return p->delaktarray (__key);
	  }
	else
	  {
	    return p->destroy (__key);
	  }
      }
    else
      return NIXKEY;
  }

  // Hier eine Version ohne Freigabemglichkeit

  // liefert alle Daten des Hashes in einer Liste zurck
  errorenum getall (rliste < keydata < DATA, unsigned >*>*__l)
  {
    unsigned x;
    smliste < DATA > *p;
    keydata < DATA, unsigned >*y;

    // laufe Hashes durch
    for (x = 0; x < _M_size; x++)
      {
	if ((p = haget (x)))
	  {
	    // laufe Liste durch
	    for (y = p->getfirst (); p->isakt (); y = p->getnext ())
	      {
		__l->insertlast (y);
	      }
	  }
      }
    return ISOK;
  }

  // Iterator ohne Listenreturn
  keydata < DATA, unsigned >*smgetfirst ()
  {
    keydata < DATA, unsigned >*ret;

    for (_M_itx = 0; _M_itx < _M_size; _M_itx++)
      if ((_M_itp = haget (_M_itx)))
	return (ret = _M_itp->getfirst ())? ret : smgetnext ();

    return NULL;
  }

  keydata < DATA, unsigned >*smgetnext ()
  {
    keydata < DATA, unsigned >*ret;

    if (_M_itp)
      if (_M_itp->isakt ())
	{
	  ret = _M_itp->getnext ();
	  if (ret)
	    return ret;
	}

    for (ret = NULL, _M_itx++; _M_itx < _M_size; _M_itx++)
      {
	_M_itp = haget (_M_itx);

	if (_M_itp)
	  if ((ret = _M_itp->getfirst ()))
	    return ret;
      }

    return NULL;
  }

  // generiert einen Key aus einer Struktur, size sind die 
  // ersten signifikanten Bytes mit sizeof(type) * x gebildet
  unsigned createkey (char *__c, unsigned __s)
  {
    register unsigned y, z;
    y = z = 0;
    while (z < __s)
      y += *__c++ << z++ % 24 + 1;
    return y;
  }

  // setzt freedata, so das nach dem Aufruf des Destruktors
  // alle Daten erhalten bleiben
  // Dummy, ist bei dieser Hash sowieso der Fall
  void keepdata (bool __i)
  {
  }

protected:
private:
  // fr iterator
  unsigned _M_itx;
  smliste < DATA > *_M_itp;

  unsigned			//_M_aktlist, 
    _M_size;
  smliste < DATA > *_M_rl;
};


// eine Hash auf Basis der smhash, aber mit der Funktionalitt das 
// ein Wrterbuch aufgebaut wird, so das bei nur Eindeutigen Schlsseln
// eine EinEinDeutige Zuordung mit dem gefundenen Wert erfolgen kann.

// a hash on base smhash, but with functionality the one dictionary 
// is structured, with only unique one codes a unique allocation with 
// the found value to thus take place can. 

typedef enum
{
  nofree = 0,
  freekey = 1,
  freedata = 1 << 1,
  freeall = freedata | freekey,
}
kcf_e;

// bischen schreibfaul
#define uns unsigned

template < class DATA > class keyclass
{
public:
  keyclass ()
  {
    _M_data = 0;
  }

  // automatic generated key, and in *u one stores
  // __p must be a newed char* !
  keyclass (kcf_e __ff, char *__p, size_t __s, unsigned *__u)
  {
    _M_ff = __ff;
    _M_p = __p;
    _M_s = __s;
    *__u = _M_ckey = createkey (_M_p, _M_s);
    _M_data = 0;
  }

  // automatic generated key, and in *u one stores
  // __p must be a newed char* !
  keyclass (kcf_e __ff, char *__p, size_t __s, unsigned *__u, DATA __d)
  {
    _M_ff = __ff;
    _M_p = __p;
    _M_s = __s;
    *__u = _M_ckey = createkey (_M_p, _M_s);
    _M_data = __d;
  }

  // commited key
  // __p must be a newed char* !
  keyclass (kcf_e __ff, char *__p, size_t __s, unsigned __k)
  {
    _M_ff = __ff;
    _M_p = __p;
    _M_s = __s;
    _M_ckey = __k;
    _M_data = 0;
  }

  // commited key
  // __p must be a newed char* !
  keyclass (kcf_e __ff, char *__p, size_t __s, unsigned __k, DATA __d)
  {
    _M_ff = __ff;
    _M_p = __p;
    _M_s = __s;
    _M_ckey = __k;
    _M_data = __d;
  }

  ~keyclass ()
  {
    if ((_M_ff & freekey))
      {
	delete[]_M_p;
      }

    if ((_M_ff & freedata))
      {
	delete _M_data;
      }
  }

  // to read the only once generated key
  unsigned getckey ()
  {
    return _M_ckey;
  }

  DATA _M_data;
  char *_M_p;
  size_t _M_s;

protected:
private:
  // generiert einen Key aus einer Struktur, size sind die 
  // ersten signifikanten Bytes mit sizeof(type) * x gebildet
  unsigned createkey (char *__c, unsigned __s)
  {
    register unsigned y, z;
    y = z = 0;
    while (z < __s)
      y += *__c++ << ((z++ % 24) + 1);
    return y;
  }

  unsigned _M_ckey;
  kcf_e _M_ff;
};

// ####################################################################################
#define HASHTYPE smhash < SIZE, keyclass <DATA> * >
template < unsigned SIZE, class DATA > class smhasheed:public HASHTYPE
{
public:
  smhasheed ():HASHTYPE ()
  {
  }

  errorenum insert (keyclass < DATA > *__key)
  {
    unsigned k = __key->getckey ();

    // fge Daten mit Hashwert in Hash ein
    // add data with hashvalue in Hash
    if (HASHTYPE::insert (k, __key))
      return NOOK;

    return ISOK;
  }

  // Gibt die Daten die zum key gehren zurck, in error steht ob der
  // Key gefunden wurde oder nicht
  // diese Funktion darf nur genutzt werden wenn sichergestellt 
  // ist das die Keys eindeutig sind.

  void search_nonext (keyclass < DATA > *__key, errorenum * __e)
  {
    keyclass < DATA > *kd;
    // save for call searchdoppel
    HASHTYPE::search (&kd, __key->getckey (), __e);
    __key->_M_data = kd->_M_data;
  }

  // search does support searchnext
  bool search_nonext_next (keyclass < DATA > *__key, errorenum * __error)
  {
    keyclass < DATA > *kd;
    bool ret;
    // search next value
    ret = HASHTYPE::searchdoppel (&kd, __error);
    __key->_M_data = kd->_M_data;
    return ret;
  }

  // search does support searchnext
  bool search (keyclass < DATA > *__key, errorenum * __error)
  {
    errorenum e;
    keyclass < DATA > *kd;

    // search first value
    HASHTYPE::search (&kd, __key->getckey (), &e);

    *__error = e;
    if (e == NIXKEY)
      return GOERROR;

    // Ist der erste Wert richtig?
    // Is the first value correct?   
    if (memcmp_int (kd->_M_p, __key->_M_p, __key->_M_s))
      {
	*__error = ISOK;
	__key->_M_data = kd->_M_data;
	return NOERROR;
      }

    return search_second (__key, __error);
  }


  // search does support searchnext
  bool search_next (keyclass < DATA > *__key, errorenum * __error)
  {
    keyclass < DATA > *kd;

    // search first value
    while (HASHTYPE::searchdoppel (&kd, __error))
      {
	// Ist der erste Wert richtig?
	// Is the first value correct?   
	if (memcmp_int (kd->_M_p, __key->_M_p, __key->_M_s))
	  {
	    __key->_M_data = kd->_M_data;
	    return true;
	  }
      }

    return false;
  }

protected:

private:
  // search the next hash entry
  // return true if next is thinkable
  bool search_second (keyclass < DATA > *__key, errorenum * __error)
  {
    keyclass < DATA > *kd;
    errorenum e;

    while (HASHTYPE::searchdoppel (&kd, &e))
      {
	if (memcmp_int (kd->_M_p, __key->_M_p, __key->_M_s))
	  {
	    *__error = ISOK;
	    __key->_M_data = kd->_M_data;
	    return NOERROR;
	  }
      }
    return GOERROR;
  }

};

#undef HASHTYPE


// Stack / LIFO
//
// implementiert einen Stack auf Basis des Arrays.
template < class DATA > class hstack:public larray < DATA >
{
public:
hstack (unsigned __x):larray < DATA > (__x)
  {
    _M_cnt = 0;
  }

hstack ():larray < DATA > ()
  {
    _M_cnt = 0;
  }

  ~hstack ()
  {
  }

  errorenum push (DATA __i)
  {
    errorenum e = insertlast (__i);	// fgt hinter dem letzen ein
    _M_cnt++;
    return e;
  }
  DATA pop ()
  {
    _M_cnt--;
    return getlastrm ();
  }
  long getcnt ()
  {
    return _M_cnt;
  }

  // gibt counter zurck auf Basis des Arrays. << " maxset=" << maxset << "\n";n private:
  long _M_cnt;

};


// FIFO 
//
// auf Basis der Ringliste 
template < class DATA > class hfifo:public harray < DATA >
{
public:
  hfifo (unsigned __x):harray < DATA > (__x)
  {
    _M_cnt = _M_first = _M_last = 0;
    _M_len = __x;
  }
hfifo ():harray < DATA > ()
  {
    _M_cnt = _M_first = _M_last = 0;
    _M_len = DEFSIZE;
  }

  ~hfifo ()
  {
  }

  // legt auf den Stapel
  errorenum push (DATA __i)
  {
    if (haset (_M_last++, __i))	// fgt hinter dem letzen ein und beginnt am Ende wieder von vorn
      {
	return NOOK;
      }

    if (_M_last > _M_len)
      _M_last = 0;

    _M_cnt++;

    return ISOK;
  }

  // zieht von unten aus dem Stapel raus
  DATA pull ()
  {
    DATA r = haget (_M_first++);

    if (_M_first > _M_len)
      _M_first = 0;
    _M_cnt--;
    return r;
  }

  void resize (unsigned long __r)	// fgt immer hinten ein, vergrert das Array
  {
    _M_len = __r;
  }

  // lscht alle Objekte fr die es Zeiger im Array gibt,    
  // setzt akt auf 0 so das mit "insert" wieder neue daten geschrieben werden knnen
  void delall ()
  {
    unsigned x;

    for (x = _M_first; x <= _M_last; x++)
      {
	if (_M_a[x])
	  delete _M_a[x];
	_M_a[x] = NULL;
      }
    _M_cnt = _M_first = _M_last = 0;
  }

  void delallarray ()
  {
    long int x;

    for (x = _M_first; x <= _M_last; x++)
      {
	if (_M_a[x])
	  delete[]_M_a[x];
	_M_a[x] = NULL;
      }
    _M_cnt = _M_first = _M_last = 0;
  }

  long getcnt ()
  {
    return _M_cnt;
  }
  // gibt aus wieviele noch zu poppen sind im Array gibt,    
  // setzt akt auf 0 so das mit "insert" wieder neue Daten geschrieben werden knnen private:
  unsigned _M_first, _M_last, _M_len;
  long _M_cnt;
};


// ***************************************************
// Hash
//
// Verwendet das Array als Basisklasse

// Enum fr die Flagverwaltung der salist (SubArrayListe)
typedef enum Flag
{
  _E_Leer = 0x0,
  _E_Unsorted = 0x1,
  _E_Fragment = 0x2
}
_T_flagtype;

// Klasse fr das Subarray des hash, kann man aber auch so verwenden 
// wenn man eine Liste mit sortierten Members braucht, wobe da leider
// die Sortorder vorgegeben ist. Sonst wrde das einfgen in die Hash 
// nicht klappen

// salist ist eine Liste of Keydatas 
template < class DATA, class KEY > class salist:
public larray < keydata < DATA, KEY > *>, public hqsort < DATA, KEY >
{
public:
  salist (unsigned __x):larray < keydata < DATA, KEY > *>(__x)
  {
    _M_flag = _E_Leer;
  }

  salist (unsigned __x, KEY __k, DATA __d):larray < keydata < DATA,
    KEY > *>(__x)
  {
    _M_flag = _E_Leer;
    // gleich eins einfgen
    insert (__k, __d);
  }

  ~salist ()
  {
    keydata < DATA, KEY > *p;

    for (p = getfirst (); getnext (p);)
      {
	if (p)
	  {
	    delete p;
	  }
      }
  }

  // Einfgen in die Liste
  errorenum update (KEY __k, DATA __d)
  {
    if (!__k)
      {
	cerr << "Warnung, Key war 0 ist unzulssig!\n";
	return KEYNULL;
      }

    // suche 0 Position und fge ein
    // da rechts die kleinen stehen suche von Rechts
    keydata < DATA, KEY > *p;

    for (p = getfirst (); getnext (p);)
      {
	if (p)
	  {
	    if (p->_M_key == __k)	// ist Key Null dann berschreiben
	      {
		p->_M_key = __k;
		p->_M_data = __d;
		return ISOK;
	      }
	  }
      }
    return insert (__k, __d);	// fgt ein und rckt "akt" auf das nchste leere
  }

  // Einfgen in die Liste
  errorenum insert (KEY __k, DATA __d)
  {
    if (!__k)
      {
	cerr << "Warnung, Key war 0 ist unzulssig!\n";
	return KEYNULL;
      }

    _M_flag |= _E_Unsorted;	// Auf jeden Fall nach dem Einfgen

    // ist Fragmentiert, dann flle Fragmente auf
    if (_M_flag & _E_Fragment)
      {
	// suche 0 Position und fge ein
	// da rechts die kleinen stehen suche von Rechts
	keydata < DATA, KEY > *p;

	for (p = getfirst (); getnext (p);)
	  {
	    if (p)
	      {
		if (!p->_M_key)	// ist Key Null dann berschreiben
		  {
		    p->_M_key = __k;
		    p->_M_data = __d;
		    return ISOK;
		  }
	      }
	  }

	// nichts gefunden, Fragmentierung ist aufgehoben
	_M_flag &= ~_E_Fragment;
      }

    keydata < DATA, KEY > *kd = new keydata < DATA, KEY > (__k, __d);
    return insertlast (kd);	// fgt ein und rckt "akt" auf das nchste leere
  }

  // sortiert
  void sort ()
  {
    qsort (_M_a, _M_maxset);
    _M_flag &= ~_E_Unsorted;
  }

  DATA bsearch (KEY __key, errorenum * __err)
  {
    keydata < DATA, KEY > *d = NULL;

    if (_M_flag & _E_Unsorted)
      {
	// Hier typengerecht sortieren
	qsort (_M_a, _M_maxset);
	_M_flag &= ~_E_Unsorted;
      }

    reks (0, _M_maxset, __key, &d);

    if (d)
      {
	*__err = ISOK;
	return d->_M_data;
      }
    else
      {
	*__err = NIXKEY;
	return (DATA) 0;
      }
  }

  // del mit der Mglichkeit auf den Zeiger der auf die Daten zeigt
  // ein delete zu geben, Das Problem ist aber eine Deklaration ohne
  // Pointer, da kann es sein das der Compiler streikt!
  errorenum destroy (KEY __key, freeenum __del)
  {
    keydata < DATA, KEY > *d = NULL;

    if (_M_flag & _E_Unsorted)
      {
	qsort (_M_a, _M_maxset);
	_M_flag &= ~_E_Unsorted;
      }

    reks (0, _M_maxset, __key, &d);

    if (d)
      {
	d->_M_key = (KEY) 0;

	// wenn gewnscht
	if (__del == HFREE)
	  {
	    if (d->_M_data)
	      delete d->_M_data;
	  }

	d->_M_data = (DATA) 0;

	_M_flag |= _E_Unsorted | _E_Fragment;
	return ISOK;
      }

    return NOOK;
  }

  errorenum destroyarray (KEY __key, freeenum __del)
  {
    keydata < DATA, KEY > *d = NULL;

    if (_M_flag & _E_Unsorted)
      {
	qsort (_M_a, _M_maxset);
	_M_flag &= ~_E_Unsorted;
      }

    reks (0, _M_maxset, __key, &d);

    if (d)
      {
	d->key = (KEY) 0;

	// wenn gewnscht
	if (__del == HFREE)
	  {
	    if (d->data)
	      delete[]d->data;
	  }

	d->data = (DATA) 0;

	_M_flag |= _E_Unsorted | _E_Fragment;
	return ISOK;
      }

    return NOOK;
  }

  // del ohne der Mglichkeit auf den Zeiger der auf die Daten zeigt
  // ein delete zu geben
  errorenum destroy (KEY __key)
  {
    keydata < DATA, KEY > *d = NULL;

    if (_M_flag & _E_Unsorted)
      {
	qsort (_M_a, _M_maxset);
	_M_flag &= ~_E_Unsorted;
      }

    reks (0, _M_maxset, __key, &d);

    if (d)
      {
	d->_M_key = (KEY) 0;
	d->_M_data = (DATA) 0;
	_M_flag |= _E_Unsorted | _E_Fragment;
	return ISOK;
      }

    return NOOK;
  }

  // setzt alle Daten auf NULL, und gibt Speicher frei
  void delall ()
  {
    unsigned x;
    keydata < DATA, KEY > *d = NULL;

    for (x = 0; x <= _M_maxset; x++)
      {
	d = haget (x);
	if (d)
	  {
	    d->_M_key = (KEY) 0;

	    if (d->_M_data)
	      delete d->_M_data;
	    d->_M_data = (DATA) 0;
	  }
      }
  }

  void delallarray ()
  {
    unsigned x;
    keydata < DATA, KEY > *d = NULL;

    for (x = 0; x <= _M_maxset; x++)
      {
	d = haget (x);
	if (d)
	  {
	    d->_M_key = (KEY) 0;

	    if (d->_M_data)
	      delete[]d->_M_data;
	    d->_M_data = (DATA) 0;
	  }
      }
  }

private:
  // Da die Liste vorsortiert ist, kann man sich viel Sucherei ersparen !
  void reks (unsigned __von, unsigned __bis, KEY __key, keydata < DATA,
	     KEY > **__d)
  {
    keydata < DATA, KEY > *kd;
    unsigned pos = __von + ((__bis - __von) / 2);

    kd = getselektor (pos);

    if (kd->_M_key != __key)
      {
	if (kd->_M_key > __key)	// links ist Grer, mu mit qsort zusammenspielen !
	  {
	    pos--;
	    if (pos >= __von && pos <= __bis)
	      reks (__von, pos, __key, __d);
	  }
	else
	  {
	    pos++;
	    if (pos <= __bis && pos >= __von)
	      reks (pos, __bis, __key, __d);
	  }
      }
    else
      {
	// schreibe nur Pointer wenn was gefunden wird
	*__d = kd;
      }
  }

  char _M_flag;
};


// Das Hash - Array ist ein Array of Listpointer 

template < class DATA, class KEY > class hhash:
public harray < salist < DATA, KEY > *>
{
public:
  // Hash Array vom Type "salist"
hhash ():harray < salist < DATA, KEY > *>(DEFSIZE)
  {
    _M_asize = DEFSIZE;
    _M_lsize = SUBASIZE;
    _M_itlist = NULL;
    _M_ithash = 0;
  }

  // x ist die zu Erwartende Gesamtanzahl
  hhash (unsigned __x):harray < salist < DATA, KEY > *>
    (_M_asize = nextprimzahl (__x > 0xff ? __x / (0xf * 2) + 0xf : 0xff))
  {
    //asize = x > 0xff ? x / (0xf * 2) + 0xf : 0xff;
    //asize = nextprimzahl (asize);

    _M_lsize = nextprimzahl (__x > 0xff ? 0xf * 2 : 0xf);
    _M_itlist = NULL;
    _M_ithash = 0;
  }

  // hier ist x die Gre des Hash Arrays und y die Gre des sortierten Arrays
  //    Arraysize    Subarraysize
  hhash (unsigned __x, unsigned __y):harray < salist < DATA,
    KEY > *>(_M_asize = nextprimzahl (__x))
  {
    // asize = nextprimzahl (x);
    _M_lsize = nextprimzahl (__y);
    _M_itlist = NULL;
    _M_ithash = 0;
  }

  ~hhash ()
  {
    salist < DATA, KEY > *p;

    // lsche alle Listen
    for (unsigned x = 0; x < _M_asize; x++)
      {
	if ((p = haget (x)))
	  {
	    delete p;
	  }
      }
  }

  // setzt alle daten auf NULL
  void delall ()
  {
    salist < DATA, KEY > *p;

    // lsche alle Listen
    for (unsigned x = 0; x < _M_asize; x++)
      {
	if ((p = haget (x)))
	  {
	    p->delall ();
	  }
      }
  }

  // setzt alle daten[] auf NULL
  void delallarray ()
  {
    salist < DATA, KEY > *p;

    // lsche alle Listen
    for (unsigned x = 0; x < _M_asize; x++)
      {
	if ((p = haget (x)))
	  {
	    p->delallarray ();
	  }
      }
  }

  // Initialisiert leeren Pointer und Fgt neue Liste ein, prft nicht ob der
  // Schlssel eindeutig ist, bei doppelten Aufrufen wird der Schlssel doppelt
  // eingefgt!
  errorenum insert (KEY __key, DATA __data)
  {
    if (!__key)
      {
	return KEYNULL;		// Key 0 ist reserviert fr das lschen im Array
      }
    return insertnokey (__key, __data);
  }

  // Initialisiert leeren Pointer und Fgt neue Liste ein, prft! ob der
  // Schlssel eindeutig ist, falls der Schlssel schon vorhanden ist dann
  // wird NOOK zurckgegeben
  errorenum insertuni (KEY __key, DATA __data)
  {
    DATA d;
    // Key prfen
    salist < DATA, KEY > *p;
    errorenum ok;

    if (!__key)
      {
	return KEYNULL;
      }

    if ((p = haget ((__key - 1) % _M_asize)))
      {
	d = p->bsearch (__key, &ok);	// alles liegt in Hand der Liste

	if (ok == ISOK)
	  {
	    return NOOK;	// schon gefunden, nicht doppelt einfgen
	  }
      }
    // hier kommen wir nur hin wenn es key noch nicht gibt 
    // insert ohne keyprfung auf 0
    return insertnokey (__key, __data);
  }

  // Initialisiert leeren Pointer und Fgt neue Liste ein, prft! ob der
  // Schlssel eindeutig ist, wenn nicht werden die Daten des alten Schlssels
  // berschrieben
  errorenum update (KEY __key, DATA __data)
  {
    DATA d;
    // Key prfen
    salist < DATA, KEY > *p;
    errorenum ok;

    if (!__key)
      {
	return KEYNULL;
      }

    if ((p = haget ((__key - 1) % _M_asize)))
      {
	d = p->bsearch (__key, &ok);	// alles liegt in Hand der Liste

	if (ok == ISOK)
	  {
	    return p->update (__key, __data);
	  }
      }
    // hier kommen wir nur hin wenn es key noch nicht gibt 
    // insert ohne keyprfung auf 0
    return insertnokey (__key, __data);
  }

  // Gibt die Daten die zum key gehren zurck, in error steht ob der
  // Key gefunden wurde oder nicht
  void search (DATA * __data, KEY __key, errorenum * __error)
  {
    salist < DATA, KEY > *p;

    if (!__key)
      {
	*__error = KEYNULL;
	*__data = (DATA) 0;
	return;			// Key 0 ist reserviert fr das lschen im Array
      }

    if ((p = haget ((__key - 1) % _M_asize)))
      {
	*__data = p->bsearch (__key, __error);	// alles liegt in Hand der Liste
	return;
      }
    else
      {
	*__error = NIXKEY;
	*__data = (DATA) 0;	// nichtmal die Liste gibt es !
	return;
      }
  }

  // Lscht den Member key, es wird der Speicher auf den "data" zeigt mit einem
  // delete wenn del auf HFREE stand. Der Speicher fr die Hash oder die SortListe
  // wird nicht freigegeben, sondern nur mit 0 markiert, so das spter dort ein neuer
  // Member gespeichert werden kann. Ist del HNOFREE wird nur 0 markiert und nichts
  // freigegeben.
  errorenum destroy (KEY __key, freeenum __del)
  {
    salist < DATA, KEY > *p;

    if (!__key)
      {
	return KEYNULL;		// Key 0 ist reserviert fr das lschen im Array
      }

    if ((p = haget ((__key - 1) % _M_asize)))
      {
	return p->destroy (__key, __del);	// alles liegt in Hand der Liste
      }
    else
      {
	return NIXKEY;		// nichtmal die Liste gibt es !
      }
  }

  errorenum destroyarray (KEY __key, freeenum __del)
  {
    salist < DATA, KEY > *p;

    if (!__key)
      {
	return KEYNULL;		// Key 0 ist reserviert fr das lschen im Array
      }

    if ((p = haget ((__key - 1) % _M_asize)))
      {
	return p->destroyarray (__key, __del);	// alles liegt in Hand der Liste
      }
    else
      {
	return NIXKEY;		// nichtmal die Liste gibt es !
      }
  }

  // Hier eine Version ohne Freigabemglichkeit
  errorenum destroy (KEY __key)
  {
    salist < DATA, KEY > *p;

    if (!__key)
      {
	return KEYNULL;		// Key 0 ist reserviert fr das lschen im Array
      }

    if ((p = haget ((__key - 1) % _M_asize)))
      {
	return p->destroy (__key);	// alles liegt in Hand der Liste
      }
    else
      {
	return NIXKEY;		// nichtmal die Liste gibt es !
      }
  }

  // Fr iterator ber ganze hash, mu immer vor getnext aufgerufen werden.
  DATA getfirst (KEY * __k)
  {
    _M_itlist = NULL;
    _M_ithash = 0;
    return getfirsti (__k);
  }

  // Fr iterator ber ganze hash, mu immer vor getnext aufgerufen werden.
  // holt nchstes
  DATA getnext (KEY * __k, errorenum * __err)
  {
    keydata < DATA, KEY > *p;

    if (_M_itlist)
      {
	//p = _M_itlist->getnext ();
	//if (p)
	if (_M_itlist->getnext (p))
	  {
	    // key kann hier nicht mehr null sein, da gefirst
	    // weitergerckt ist, falls hier doch eine 0 kommt
	    // hat was mit der Sortierung nicht hin
	    *__k = p->_M_key;
	    return p->_M_data;
	  }
	else
	  {
	    //if ((ithash + 1) <= asize)
	    if (_M_ithash < _M_asize)
	      {
		_M_itlist = NULL;
		return getfirsti (__k);
	      }
	    else
	      {
		*__err = NIXKEY;
		*__k = (KEY) 0;
		return (DATA) 0;
	      }
	  }
      }
    *__k = (KEY) 0;
    return (DATA) 0;
  }

  // generiert einen Key aus einer Struktur, size sind die 
  // ersten signifikanten Bytes mit sizeof(type) * x gebildet
  KEY createkey (char *__c, unsigned __s)
  {
    register unsigned y, z;
    y = z = 0;
    while (z < __s)
      y += *__c++ << z++ % 24 + 1;
    return y;
  }

private:
  // Die interne getfirst Funktion, pos ist die entsprchtende Startposition der Liste
  // im Hash
  DATA getfirsti (KEY * __k)
  {
    keydata < DATA, KEY > *p;

  nochmal:
    while (!_M_itlist)
      {
	_M_itlist = haget (_M_ithash++);

	if (!_M_itlist)
	  {
	    if (_M_ithash >= _M_asize)	// ithash ist Index, asize ist Gre
	      {
		*__k = (KEY) 0;
		return (DATA) 0;
	      }
	  }
      }

    if (_M_itlist)		// drbergegriffen ?
      {
	if ((p = _M_itlist->getfirst ()))	// Liste getfirst
	  {
	    // getfirst kann zufllig auch 0 liefern
	    if (p->_M_key)
	      {
		*__k = p->_M_key;
		return p->_M_data;
	      }
	    else
	      {
		while (p)
		  {
		    //p = _M_itlist->getnext ();
		    _M_itlist->getnext (p);
		    if (p->_M_key)
		      {
			*__k = p->_M_key;
			return p->_M_data;
		      }
		  }
		// falls wir hier sind dann ist sogut wie alles
		// schiefgegangen
		_M_itlist = NULL;
		goto nochmal;

	      }
	  }
      }

    *__k = (KEY) 0;
    return (DATA) 0;
  }

  // Initialisiert leeren Pointer und Fgt neue Liste ein, prft nicht ob der
  // Schlssel eindeutig ist
  errorenum insertnokey (KEY __key, DATA __data)
  {
    salist < DATA, KEY > *p;

    _M_mod = (__key - 1) % _M_asize;
    // Daten fr die Liste
    if ((p = haget (_M_mod)))	// hole Zeiger
      {
	// Daten einfgen
	return (p->insert (__key, __data));
      }
    else
      {
	// Init und einfgen,
	// Member der salist sind Keydata !
	p = new salist < DATA, KEY > (_M_lsize, __key, __data);
	if (p)
	  {
	    _M_a[_M_mod] = p;	// neues Mitglied speichern
	    return ISOK;
	  }
	else
	  return NOOK;
      }
  }

  unsigned _M_asize, _M_lsize, _M_mod, _M_ithash;

  salist < DATA, KEY > *_M_itlist;
};



// Ende mit der Schreibfaulheit
#undef unsigned


// **-*** die Super X-D-Hash als Vater fr die Wrapperklassen die dann angewendet werden  *****

template < class DATA, class KEYSTRUCT, class KEY, char DIM, unsigned int KNT,
  unsigned char BITS > class xdhasht:public harray < void *>
{
public:
  xdhasht ():harray < void *>(KNT + 1)
  {
    _M_dim = DIM - 1;
    _M_fdata = 1;		// Daten werden mit gefreet !!
    initarrays ();
  };

  ~xdhasht ()
  {
    void *p;

    // lscht Rekursiv alle Objekte, nicht die Userdaten !
    for (KEY x = 0; x < getsize (); x++)
      if ((p = haget (x)))
	{
	  if (_M_dim)
	    {
	      if (p)
		delete (xdhasht *) p;
	    }
	  else
	    {
	      if (p && _M_fdata)
		//delete (keydata < DATA, KEY > *)p;
		delete (DATA *) p;
	    }
	}
  }

  // setzt freedata, so das nach dem Aufruf des Destruktors
  // alle daten erhalten bleiben
  void keepdata (bool __i)
  {
    _M_fdata = __i;
  }

  // fgt Member hinzu und warnt
  errorenum insert (KEY __key, DATA __data)
  {
    return insert (__key, __data, true);	// Warnt
  }

  // fgt Member hinzu und warnt nicht falls Member schon vorhanden ist
  errorenum update (KEY __key, DATA __data)
  {
    return insert (__key, __data, false);	// Warnt nicht
  }

  // sucht rekusriv nach den Daten
  void search (DATA * __data, KEY __key, errorenum * __error)
  {
    void *p;
    KEY k = calckey (__key);
    if ((p = haget (k)))
      {
	if (_M_dim)
	  {
	    ((xdhasht *) p)->search (__data, __key, __error);
	  }
	else
	  {
	    *__data = (DATA) p;
	  }
	*__error = ISOK;
      }
    else
      {
	*__error = NIXKEY;
      }
  }

  // gibt die Keydata wieder frei, auch die Userdaten !!!
  void destroy (KEY __key, errorenum * __error)
  {
    void *p;
    KEY k = calckey (__key);
    if ((p = haget (k)))
      {
	if (_M_dim)
	  {
	    ((xdhasht *) p)->destroy (__key, __error);
	  }
	else
	  {
	    //delete (keydata < DATA, KEY > *)p;
	    delete (DATA) p;
	    // setze Array NULL Pointer um Doppelbelegung zu testen
	    haset (k, NULL);
	    *__error = ISOK;
	  }
      }
  }

  void destroyarray (KEY __key, errorenum * __error)
  {
    void *p;
    KEY k = calckey (__key);
    if ((p = haget (k)))
      {
	if (_M_dim)
	  {
	    ((xdhasht *) p)->destroyarray (__key, __error);
	  }
	else
	  {
	    //delete[](keydata < DATA, KEY > *)p;
	    delete (DATA) p;
	    // setze Array NULL Pointer um Doppelbelegung zu testen
	    haset (k, NULL);
	    *__error = ISOK;
	  }
      }
  }

  // gibt alle Daten des Hashes zurck, in Form einer Liste
  void getall (larray < DATA > *__list, errorenum * __error)
  {
    KEY x;
    void *p;
    *__error = NOOK;

    for (x = 0; x <= KNT; x++)	//  0 ... 0xff
      {
	if ((p = haget (x)))
	  {
	    if (_M_dim)
	      {
		((xdhasht *) p)->getall (__list, __error);
	      }
	    else
	      {
		__list->insert ((DATA) p);
		*__error = ISOK;
	      }
	  }			// if p
      }				// for ; aktptr
  }

  // lscht alle Daten
  void delall ()
  {
    KEY x;
    void *p;

    for (x = 0; x <= KNT; x++)	//  0 ... 0xff
      {
	if ((p = haget (x)))
	  {
	    if (_M_dim)
	      {
		((xdhasht *) p)->delall ();
	      }
	    else
	      {
		delete (DATA) p;
		haset (x, NULL);
	      }
	  }			// if p
      }				// for ; aktptr
  }

  // lscht alle Daten
  void delallarray ()
  {
    KEY x;
    void *p;

    for (x = 0; x <= KNT; x++)	//  0 ... 0xff
      {
	if ((p = haget (x)))
	  {
	    if (_M_dim)
	      {
		((xdhasht *) p)->delallarray ();
	      }
	    else
	      {
		delete[](DATA) p;
		haset (x, NULL);
	      }
	  }			// if p
      }				// for ; aktptr
  }


  // generiert einen Key aus einer Struktur, size sind die 
  // ersten signifikanten Bytes mit sizeof(type) * x gebildet
  KEY createkey (KEYSTRUCT __data, unsigned __s)
  {
    const char *c = (char *) __data;
    register unsigned y, z;
    y = z = 0;
    while (z < __s)
      y += *c++ << z++ % 24 + 1;
    return y;
  }

  // generiert einen Key aus einer Struktur, size sind die 
  // ersten signifikanten Bytes mit sizeof(type) * x gebildet
  unsigned createkey (char *__c, unsigned __s)
  {
    register unsigned y, z;
    y = z = 0;
    while (z < __s)
      y += *__c++ << z++ % 24 + 1;
    return y;
  }

protected:
  // Schlsselberechnung
  KEY calcidx (KEY __key)
  {
    // es gibt keine Hash-Funktion, es wird direkt die 
    // Adresse berechnet
    return ((__key & KNT) << _M_shift[_M_dim]);
  }

  // Schlsselberechnung
  KEY calckey (KEY __key)
  {
    // es gibt keine Hash-Funktion, es wird direkt die 
    // Adresse berechnet
    return ((__key & _M_und[_M_dim]) >> _M_shift[_M_dim]);
  }

  // Schlsselberechnung
  KEY calckey (KEY __key, char __di)
  {
    // es gibt keine Hash-Funktion, es wird direkt die 
    // Adresse berechnet
    return ((__key & _M_und[__di]) >> _M_shift[__di]);
  }



  //  Konstruktor fr interne Zwecke, anlegen der neuen Dimension
xdhasht (char __d):harray < void *>(KNT + 1)
  {
    _M_dim = __d;
    initarrays ();
  }

  // in Welcher Dimension ich bin?
  char _M_dim;


private:
  // fgt Member hinzu und new't wenn erforderlich die Datenstrukturen
  // ist der Schlssel schon vergeben gewesen, dann wird einfach berschrieben
  errorenum insert (KEY __key, DATA __data, bool __warn)
  {
    void *p;
    KEY k = calckey (__key);

    if (!(p = haget (k)))
      //if (!p)
      {
	if (_M_dim)
	  {
	    p = (void *) new xdhasht (_M_dim - 1);

	    haset (k, p);	// setze Array

	    // geht rek runter !
	    ((xdhasht *) p)->insert (__key, __data, __warn);
	  }
	else
	  {
	    // Rekursionsende
	    p = (void *) __data;
	    haset (k, p);	// setze Array
	  }

	if (p)
	  return ISOK;
	else
	  return NOOK;
      }
    else
      {
	if (_M_dim)
	  {
	    ((xdhasht *) p)->insert (__key, __data, __warn);
	  }
	else
	  {
	    if (p && __warn)
	      cerr << "hash: der Key war schon da! Fge ein Key=" << __key <<
		" Data=" << __data << endl;
	    p = (void *) __data;
	    haset (k, p);
	  }
      }
    return ISOK;
  }


  // fr Konstruktor
  void initarrays ()
  {
    for (int x = 0; x < 4; x++)
      {
	_M_shift[x] = x * BITS;
	_M_und[x] = KNT << _M_shift[x];
      }

    /*
       Hier mal die Bitmuster zum nachlesen.
       // ** Long & Integer **
       shift[3] = 3 * 8;
       shift[2] = 2 * 8;
       shift[1] = 1 * 8;
       shift[0] = 0 * 8;
       und[3] = 0xff000000;
       und[2] = 0x00ff0000;
       und[1] = 0x0000ff00;
       und[0] = 0x000000ff;
     */

    /*  ** Short **
       shift[3] = 3 * 4;
       shift[2] = 2 * 4;
       shift[1] = 1 * 4;
       shift[0] = 0 * 4;

       und[3] = 0xf000;
       und[2] = 0x0f00;
       und[1] = 0x00f0;
       und[0] = 0x000f;

       **  Char **
       shift[3] = 3 * 2;
       shift[2] = 2 * 2;
       shift[1] = 1 * 2;
       shift[0] = 0 * 2;

       und[3] = 0xC0;  ->  II000000
       und[2] = 0x30;  ->  00II0000
       und[1] = 0x0C;  ->  0000II00
       und[0] = 0x03;  ->  000000II
     */
  }

  // Schift und & Werte fr Schlsselberechnung
  char _M_shift[4];		// shift Array, je Dimension anders shift
  KEY _M_und[4];		// und Array, je Dimension anderes und

  bool _M_fdata;
};

// *************** Wrapper Klasse ****************
// da nur diese Kombinationen sinnvoll sind
// ***********************************************

// Key Adressraum ist "unsigned long"
// Vieleicht auf 0xffff und 16 setzen? Tja eine Alpha sollte
// man haben :-(
template < class DATA, class KEYSTRUCT > class xdhashlong:
//                data,   key lnge,   Kantenlnge,  Kantenlnge in Bits
public xdhasht < DATA, KEYSTRUCT, unsigned long, 8, 0xff, 8 >
{

};


// Key Adressraum ist "unsigned int"
template < class DATA, class KEYSTRUCT > class xdhashint:
public xdhasht < DATA, KEYSTRUCT, unsigned int, 4, 0xff, 8 >
{

};

// Key Adressraum ist "unsigned short"
template < class DATA, class KEYSTRUCT > class xdhashshort:
public xdhasht < DATA, KEYSTRUCT, unsigned short, 4, 0xf, 4 >
{

};

// ein wirklich kleiner Hash, Miniausfhrung fr Palm's :-)
// Key Adressraum ist "unsigned char"
template < class DATA, class KEYSTRUCT > class xdhashchar:
public xdhasht < DATA, KEYSTRUCT, unsigned char, 4, 0x3, 2 >
{

};


// Hier ein Besonderer Hash, Key vom Type char *, beliebige
// Lnge ist mglich und es wird direkt Adressiert
template < class DATA, unsigned DIM, unsigned LEN >
  class xdhashstrt:public harray < void *>
{
public:
  xdhashstrt ():harray < void *>(LEN)
  {
    _M_dim = DIM <= 256 ? DIM - 1 : 255;
    _M_keylen = DIM;
  };

  // also Achtung beim delete auf den Hash!
  // es werden die data Pointer freigegeben
  ~xdhashstrt ()
  {
    void *p;

    // lscht Rekursiv alle Objekte, nicht die Userdaten !
    for (unsigned x = 0; x < getsize (); x++)
      if ((p = haget (x)))
	{
	  if (_M_dim)
	    {
	      if (p)
		delete (xdhashstrt *) p;
	    }
	  else
	    {
	      if (p)
		delete (DATA *) p;
	    }
	}
  }


  // fgt Member hinzu und new't wenn erforderlich die Datenstrukturen
  // ist der Schlssel schon vergeben gewesen, dann wird einfach berschrieben
  // insert mit Warnung, update ohne Warnung
  errorenum insert (const char *__key, DATA __data)
  {
    return insert (__key, __data, true);
  }

  errorenum update (const char *__key, DATA __data)
  {
    return insert (__key, __data, false);
  }

  // sucht rekusriv nach den Daten
  void search (DATA * __data, const char *__key, errorenum * __error)
  {
    void *p = haget (calckey (__key));

    if (p)
      {
	if (_M_dim)
	  {
	    ((xdhashstrt < DATA, DIM, LEN > *)p)->search (__data, __key,
							  __error);
	  }
	else
	  {
	    *__data = (DATA) p;
	  }
	*__error = ISOK;
      }
    else
      {
	*__error = NIXKEY;
      }
  }


  // gibt die Keydata wieder frei, also in der letzten Ebene
  // auch die Userdaten, mit delete also Achtung beim
  // new von Arrays ! Es sollte dann ein Hash von diesem Type
  // hier abgeleitet werden und diese destroy Funkton mit der
  // gleichen Funktion hier berladen werden, halt nur anstelle
  // von delete (DATA*) p; mit delete (DATA*) []p;
  void destroy (const char *__key, errorenum * __error)
  {
    void *p;
    int k = calckey (__key);
    if ((p = haget (k)))
      {
	if (_M_dim)
	  {
	    ((xdhashstrt < DATA, DIM, LEN > *)p)->destroy (__key, __error);
	  }
	else
	  {
	    delete (DATA *) p;
	    // setze Array NULL Pointer um Doppelbelegung zu testen
	    haset (k, NULL);
	    *__error = ISOK;
	  }
      }
  }

  void destroyarray (const char *__key, errorenum * __error)
  {
    void *p;
    int k = calckey (__key);
    if ((p = haget (k)))
      {
	if (_M_dim)
	  {
	    ((xdhashstrt < DATA, DIM, LEN > *)p)->destroyarray (__key,
								__error);
	  }
	else
	  {
	    delete[](DATA *) p;
	    // setze Array NULL Pointer um Doppelbelegung zu testen
	    haset (k, NULL);
	    *__error = ISOK;
	  }
      }
  }

  // Rekursiv durch den Hash und Elemente in die Liste einfgen
  void getall (larray < DATA > *__list, errorenum * __error)
  {
    unsigned x;
    void *p;
    *__error = NOOK;

    for (x = 0; x < LEN; x++)	//  0 ... 0xff
      {
	if ((p = haget (x)))
	  {
	    if (_M_dim)
	      {
		((xdhashstrt < DATA, DIM, LEN > *)p)->getall (__list,
							      __error);
	      }
	    else
	      {
		__list->insert ((DATA) p);
		*__error = ISOK;
	      }
	  }			// if p
      }				// for ; aktptr
  }

  // lscht alle Daten
  void delall ()
  {
    unsigned x;
    void *p;

    for (x = 0; x < LEN; x++)	//  0 ... 0xff
      {
	if ((p = haget (x)))
	  {
	    if (_M_dim)
	      {
		((xdhashstrt < DATA, DIM, LEN > *)p)->delall ();
	      }
	    else
	      {
		delete (DATA) p;
		haset (x, NULL);
	      }
	  }			// if p
      }				// for ; aktptr
  }

  // lscht alle Daten Arrays
  void delallarray ()
  {
    unsigned x;
    void *p;

    for (x = 0; x < LEN; x++)	//  0 ... 0xff
      {
	if ((p = haget (x)))
	  {
	    if (_M_dim)
	      {
		((xdhashstrt < DATA, DIM, LEN > *)p)->delall ();
	      }
	    else
	      {
		delete[](DATA) p;
		haset (x, NULL);
	      }
	  }			// if p
      }				// for ; aktptr
  }

private:
  errorenum insert (const char *__key, DATA __data, bool __warn)
  {
    void *p;
    int k = calckey (__key);

    if (!(p = haget (k)))
      //if (!p)
      {
	if (_M_dim)
	  {
	    p = (void *) new xdhashstrt < DATA, DIM, LEN > (_M_dim);
	    haset (k, p);	// setze Array
	    ((xdhashstrt < DATA, DIM, LEN > *)p)->insert (__key, __data,
							  __warn);
	  }
	else
	  {
	    // Rekursionsende
	    p = (void *) __data;
	    haset (k, p);	// setze Array
	  }

	if (p)
	  return ISOK;
	else
	  return NOOK;
      }
    else
      {
	if (_M_dim)
	  {
	    ((xdhashstrt < DATA, DIM, LEN > *)p)->insert (__key, __data,
							  __warn);
	  }
	else
	  {
	    if (p && __warn)
	      cerr << "hash: der Key war schon da! Fge ein Key=" << __key <<
		" Data=" << __data << endl;
	    p = (void *) __data;
	    haset (k, p);
	  }
      }
    return ISOK;
  }

xdhashstrt (unsigned int __d):harray < void *>(LEN)
  {
    _M_dim = __d <= 256 ? __d - 1 : 255;
    _M_keylen = __d;
  };

  // Schlsselberechnung
  char calckey (const char *__y)
  {
    if (_M_dim < _M_keylen)
      {
	return __y[_M_dim];
      }
    else
      {
	cerr << "Interner Fehler, Dimension " << _M_dim << " >=  strlen " <<
	  _M_keylen << " key!\n";
	return 0;
      }
  }

  // in Welcher Dimension ich bin?
  unsigned int _M_dim, _M_keylen;
};



// X-Dimensionale Hash fr Strings, Zeichenketten sind von 
//  [ 0,1,...9 ... a ... z ... A ... Z ] erlaubt,
//  Dezimal von 48 bis 122 !! Also 75 Zeichen
//  Der Vorteil ist das hier viel Speicher gespart wird, da nicht
//  256 sondern nur 75 Zeiger je Array belegt werden.
//  Der Nachteil ist natrlich die Beschrnkung auf die Zeichen 
//  und der Funktionsaufruf prepkey().
//  
template < class DATA,
  unsigned DIM > class xdhashstr:public xdhashstrt < DATA, DIM, 75 >
{
public:
  errorenum insert (const char *__key, DATA __data)
  {
    prepkey (__key);
    return xdhashstrt < DATA, DIM, 75 >::insert (_M_mkey, __data);
  }

  errorenum update (const char *__key, DATA __data)
  {
    prepkey (__key);
    return xdhashstrt < DATA, DIM, 75 >::update (_M_mkey, __data);
  }

  void search (DATA * __data, const char *__key, errorenum * __error)
  {
    prepkey (__key);
    xdhashstrt < DATA, DIM, 75 >::search (__data, _M_mkey, __error);
  }

  void destroy (const char *__key, errorenum * __error)
  {
    prepkey (__key);
    xdhashstrt < DATA, DIM, 75 >::destroy (_M_mkey, __error);
  }

  void destroyarray (const char *__key, errorenum * __error)
  {
    prepkey (__key);
    xdhashstrt < DATA, DIM, 75 >::destroyarray (_M_mkey, __error);
  }

private:
  void prepkey (const char *__key)
  {
    for (unsigned x = 0; x < DIM; x++)
      {
	_M_mkey[x] = __key[x] - 48;	// char 0

	if (_M_mkey[x] > 74)
	  {
	    cerr << "unerlaubtes char in key c=\"" << char (_M_mkey[x] +
							    48) <<
	      "\" setze zu Z\n";
	    _M_mkey[x] = 74;
	  }
      }
    _M_mkey[DIM] = 0;
  }

  // Key Array
  char _M_mkey[DIM + 1];
};


// Beispielableitung fr eine String Hash mit einer Dimensionslnge von 10 
// fr den Key der nur aus ASC Zahlen besteht also Ziffern von 0...9 A...F
template < class DATA,
  unsigned DIM > class xdhstrh:public xdhashstrt < DATA, DIM, 16 >
{
public:
  errorenum insert (const char *__key, DATA __data)
  {
    prepkey (__key);
    return xdhashstrt < DATA, DIM, 16 >::insert (_M_mkey, __data);
  }

  errorenum update (const char *__key, DATA __data)
  {
    prepkey (__key);
    return xdhashstrt < DATA, DIM, 16 >::update (_M_mkey, __data);
  }

  void search (DATA * __data, const char *__key, errorenum * __error)
  {
    prepkey (__key);
    xdhashstrt < DATA, DIM, 16 >::search (__data, _M_mkey, __error);
  }

  void destroy (const char *__key, errorenum * __error)
  {
    prepkey (__key);
    xdhashstrt < DATA, DIM, 16 >::destroy (_M_mkey, __error);
  }

  void destroyarray (const char *__key, errorenum * __error)
  {
    prepkey (__key);
    xdhashstrt < DATA, DIM, 16 >::destroyarray (_M_mkey, __error);
  }


private:

  // hexadezimale Zahlen bestehen aus char von:
  // 0 ... 9  und  a ... f
  // laut ASCII ist das dann
  // 48 ... 57 und 97 ... 102
  // also erstmal Ziffern -'0' was -48 entspricht
  // und Buchstaben -'a'+10 was -87 entspricht
  void prepkey (const char *__key)
  {
    for (unsigned x = 0; x < DIM; x++)
      {
	_M_mkey[x] = (__key[x] >= 'a') ? __key[x] - 'a' + 10 : __key[x] - '0';
      }
  }

  char _M_mkey[DIM];
};


// Heapsort, weniger zur Anwendung da Qsort besser ist, aber ist
// ganz schn klever !

template < class _T_DATA > class hsarray:public harray < _T_DATA >
{

public:
  //         Anzahl Input   Anzahl der Malloc Endlisten   Lnge Endliste
  hsarray (int __a):harray < _T_DATA > (__a + 1)
  {
    _M_size = __a;
  }

  ~hsarray ()
  {
  }

  void copy (_T_DATA * __A)
  {
    hafuell (__A);
    buildheap ();
  }

  void heapsort ()
  {
    int size = _M_size - 1;

    // nach copy verschoben,
    // buildheap ();

    for (int x = size; x > 0; x--)
      {
	// tausche __i und largest
	/*ex = haget (0);
	   haset (0, haget (x));
	   haset (x, ex); */

	_M_a[x] ^= _M_a[0];
	_M_a[0] ^= _M_a[x];
	_M_a[x] ^= _M_a[0];

	heapify (0, --size);
      }

  }

  _T_DATA getfirst ()
  {
    _M_index = 0;
    return haget (0);
  }

  bool getnext (_T_DATA & data)
  {
    _M_index++;
    if (_M_index < _M_size)
      {
	data = haget (_M_index);
	return true;
      }
    else
      {
	return false;
      }
  }

private:
  // links im Baum
  _T_DATA left (_T_DATA __i)
  {
    _T_DATA l = __i * 2;
    return l;
  }

  // rechts im Baum
  _T_DATA right (_T_DATA __i)
  {
    _T_DATA r = __i * 2 + 1;
    return r;
  }

  // Knoten und alle Unterknoten
  void heapify (unsigned int __i, unsigned int __size)
  {
    _T_DATA l, r, lar;

    l = left (__i);
    r = right (__i);


    if ((l <= __size) && (haget (l) > haget (__i)))
      lar = l;
    else
      lar = __i;

    if ((r <= __size) && (haget (r) > haget (lar)))
      lar = r;

    if (lar != __i)
      {
	// tausche __i und lar
	/*
	   ex = haget (__i);
	   haset (__i, haget (lar));
	   haset (lar, ex);
	 */

	_M_a[lar] ^= _M_a[__i];
	_M_a[__i] ^= _M_a[lar];
	_M_a[lar] ^= _M_a[__i];

	heapify (lar, __size);
      }

  }

  void buildheap ()
  {
    for (int x = _M_size / 2; x > 0; x--)
      heapify (x, _M_size);
  }


  int _M_index, _M_size;
};


// Count - Sort, ist viel schneller als der qsort, man kann halt nur Daten
// vom Type STYPE verwalten. Klasse ist nur Template fr die Folgenden
// Klassen
template < class DATA, class STYPE, int LEN > class csarray:public
  harray < DATA >
{

public:

  csarray ():harray < DATA > (LEN + 1)
  {
    _M_alen = LEN;
    _M_w = _M_pos = 0;
  }

  void countsort (DATA __anz, STYPE * __A)
  {
    for (unsigned int x = 0; x < __anz; x++)
      {
	register unsigned int d = __A[x];
	register DATA w = haget (d);
	haset (d, ++w);
      }
  }

  STYPE getnext ()
  {
    if (_M_w)
      {
	_M_w--;
	return _M_pos;
      }

    while (++_M_pos <= _M_alen)
      {

	if ((_M_w = haget (_M_pos)))
	  {
	    _M_w--;
	    return _M_pos;
	  }
      }
    return 0;
  }


  STYPE getfirst ()
  {
    _M_w = _M_pos = 0;

    while (_M_pos <= _M_alen)
      {
	if ((_M_w = haget (_M_pos)))
	  {
	    _M_w--;
	    return _M_pos;
	  }

	_M_pos++;
      }
    return 0;
  }


protected:
  unsigned int _M_w;

private:
  unsigned int _M_alen, _M_pos;
};

// Sortierverfahren die einen lineraren Zeitbedarf f(n) = ( n * x )
// Schneller als qsort !
// n = Anzahl x Bedarf fr ein Element, haben sollten, (nicht berprft :-))

// Count Sort fr Char 
class charsortarray:public csarray < unsigned int, unsigned char, 0xff >
{
};

// Count Sort fr Short
class shortsortarray:public csarray < unsigned int, unsigned short, 0xffff >
{
};


// Count - Sort, ist viel schneller als der qsort, man kann halt nur Daten
// vom Type STYPE verwalten. Klasse ist nur Template fr die Folgenden
// Klassen
// speichert Pointerlisten um mit den sortierten Zahlen was anzufangen
//              char       0xff         void *  
// oder         short      0xffff       void * 

#define CSARRAYT < unsigned int, DATA, DATALEN >

template < class DATA, int DATALEN,
  class SORTT > class cpsarray:public csarray CSARRAYT
{

public:

  cpsarray ():csarray CSARRAYT ()
  {
    unsigned int x;
      larray < SORTT > *lsp;

      _M_parray = new harray < larray < SORTT > *>(DATALEN + 2);

    for (x = 0; x < DATALEN + 1; x++)
      {
	lsp = new larray < SORTT > ();	// Pointerlisten aufbauen
	_M_parray->haset (x, lsp);
      }

  }

   ~cpsarray ()
  {
    delete _M_parray;
  }

  void pcountsort (unsigned int __anz, DATA * __A, SORTT * __B)
  {
    for (unsigned int x = 0; x < __anz; x++)
      {
	// Counter bilden
	register unsigned int pos = __A[x];
	register DATA w = haget (pos);

	haset (pos, ++w);
	// fr Counter Sortwert in Liste speichern
	(_M_parray->haget (pos))->insert (__B[x]);
      }
  }

  // noch nicht getestet!!!
  void pcountinsert (unsigned int __x, DATA * __A, SORTT * __B)
  {
    // Counter bilden
    register unsigned int pos = __A[__x];
    register DATA w = haget (pos);

    haset (pos, ++w);
    // fr Counter Sortwert in Liste speichern
    (_M_parray->haget (pos))->insert (__B[__x]);
  }


  bool getnext (DATA & __key, SORTT & __data)
  {
    //SORTT ret;
    bool err;

    // Vorgnger rufen, damit Zhler runtergesetzt werden _M_w !
    __key = _M_gp = csarray CSARRAYT::getnext ();

    if (_M_w)
      {
	err = _M_sp->getnext (__data);
	return err;
      }

    if (_M_gp)
      {
	_M_sp = _M_parray->haget (_M_gp);
	__data = _M_sp->getfirst ();
	return true;
      }

    return false;
  }

  SORTT getfirst (DATA & __data)
  {
    __data = _M_gp = csarray CSARRAYT::getfirst ();
    _M_sp = _M_parray->haget (_M_gp);
    return _M_sp->getfirst ();
  }


protected:

private:
  DATA _M_gp;
  harray < larray < SORTT > *>*_M_parray;
  larray < SORTT > *_M_sp;
};

#undef CSARRAYT

// Sortierverfahren die einen lineraren Zeitbedarf f(n) = ( n * x )
// Schneller als qsort !
// n = Anzahl x Bedarf fr ein Element, haben sollten, (nicht berprft :-))

// Count Sort fr Char 
template < class SORTTYPE > class charpsortarray:
public cpsarray < unsigned char, 0xff, SORTTYPE >
{
};

// Count Sort fr Short
template < class SORTTYPE > class shortpsortarray:
public cpsarray < unsigned short, 0xffff, SORTTYPE >
{
};


#define HISORT    	harray < unsigned short >
#define LOSORT    	harray < ENDLISTE * >
#define ENDLISTE  	larray < unsigned short >
// ist aber nicht gerade "elegant" 2 Arrays von 0xffff 
// Gre zu allocieren !
// hat aber auch einen linearen Zeitbedarf !!!
class intsortarray
{
public:
  //         Anzahl Input   Anzahl der Malloc Endlisten   Lnge Endliste
  intsortarray (unsigned int __a, unsigned int __pd)
  {
    _M_anz = __a;
    _M_subanz = __pd;

    if (DEFSIZE < 65536)
      {
	cerr << "Interner Fehler! bitte \"#define DEFSIZE 65536\" vor\n";
	cerr << "#include hash.h schreiben!\n";
      }

    for (unsigned int x = 0; x < DEFSIZE; x++)
      _M_losort.haset (x, new ENDLISTE (__pd));
  }

  ~intsortarray ()
  {
    // nicht hier, es sind nicht alle
    _M_losort.delall ();
  }

  // sortiert Eintrge
  void exsort (unsigned int *__A)
  {
    register _U_mu_union wert;

    for (unsigned int x = 0; x < _M_anz; x++)
      {
	wert.i = __A[x];

	// hi Set #### Problem #### !!!
	// wert.s.hi++;
	//_M_hisort.haset (wert.s.hi++, wert.s.hi);
	//(_M_losort.haget (wert.s.lo))->insert (wert.s.hi);

	_M_hisort.hafset (wert.s.hi++, wert.s.hi);
	(_M_losort.haget (wert.s.lo))->fastinsert (wert.s.hi);
      }
  }

  // noch nicht getestet !!!
  // sortiert Eintrge
  void exinsertsort (unsigned int __x, unsigned int *__A)
  {
    register _U_mu_union wert;

    wert.i = __A[__x];

    // hi Set #### Problem #### !!!
    // wert.s.hi++;
    //_M_hisort.haset (wert.s.hi++, wert.s.hi);
    //(_M_losort.haget (wert.s.lo))->insert (wert.s.hi);

    _M_hisort.hafset (wert.s.hi++, wert.s.hi);
    (_M_losort.haget (wert.s.lo))->fastinsert (wert.s.hi);
  }


  // liest ersten Eintrag aus dem Array
  unsigned int getfirst ()
  {
    unsigned int ret;

    _M_hiidx = _M_loidx = 0;

    while (_M_hiidx < DEFSIZE)
      {
	if ((_M_xhi = _M_hisort.haget (_M_hiidx)))
	  {
	    _M_loidx = 0;
	    if ((ret = searchlo ()))
	      {
		return ret;
	      }
	  }

	_M_hiidx++;
      }

    return 0;
  }

// liest nchsten Eintrag aus dem Array
  unsigned int getnext ()
  {
    unsigned int ret;

    if (_M_loidx < DEFSIZE)
      {
	if ((ret = searchlo ()))
	  {
	    return ret;
	  }
      }

    while (_M_hiidx < DEFSIZE)
      {
	_M_hiidx++;

	if ((_M_xhi = _M_hisort.haget (_M_hiidx)))
	  {
	    _M_loidx = 0;
	    if ((ret = searchlo ()))
	      {
		return ret;
	      }
	  }
      }
    return 0;
  }

protected:

  void getidx (unsigned int &__loidx)
  {
    __loidx = _M_loidx;
  }

// ndere DEFSIZE fr Statische Klassen
// ganz wichtig, vor include der hash.h DEFSIZE auf 0xffff setzen !!!
  HISORT _M_hisort;		// Erste Sortierung
  LOSORT _M_losort;		// Letzte Sortierung mit Listen

  unsigned int _M_anz;

private:

  unsigned int searchlo ()
  {
    ENDLISTE *el;
    register _U_mu_union ret;
    unsigned short hi;

    while (_M_loidx < DEFSIZE)
      {
	if ((el = _M_losort.haget (_M_loidx)))
	  {
	    if ((el->getfirst ()) == _M_xhi)
	      {
		ret.s.lo = _M_loidx;
		ret.s.hi = _M_xhi - 1;
		_M_loidx++;
		return ret.i;
	      }

	    while (el->getnext (&hi))
	      {
		if (hi == _M_xhi)
		  {
		    ret.s.lo = _M_loidx;
		    ret.s.hi = _M_xhi - 1;

		    _M_loidx++;
		    return ret.i;
		  }
	      }
	  }
	_M_loidx++;
      }

    return 0;
  }

  unsigned short _M_xhi;
  unsigned int _M_hiidx, _M_loidx, _M_subanz;
};



#undef ENDLISTE
#undef LOSORT

#define KEYP		keydatashort < DATA >
#define ENDLISTEP  	larray < KEYP >
#define PSORT    	harray < ENDLISTEP * >

// besser ist es wenn man die losort Liste aufbohrt und dort eine Struktur
// von short und void * speichern, dann haben wir die gleiche Zugriffszeiten

// ist aber nicht gerade "elegant" 2 Arrays von 0xffff 
// Gre zu allocieren !
// hat aber auch einen linearen Zeitbedarf !!!
// Sortiert die Pointer mit 
template < class DATA > class intpsortarray
{
public:
  //         Anzahl Input   Anzahl der Malloc Endlisten   Lnge Endliste
  intpsortarray (unsigned int __a, unsigned int __pd)
  {
    _M_anz = __a;
    _M_subanz = __pd;

    if (DEFSIZE < 65536)
      {
	cerr << "Interner Fehler! bitte \"#define DEFSIZE 65536\" vor\n";
	cerr << "#include hash.h schreiben!\n";
      }

    for (unsigned int x = 0; x < DEFSIZE; x++)
      _M_psort.haset (x, new ENDLISTEP (__pd));
  }

  ~intpsortarray ()
  {
    // nicht hier, es sind nicht alle
    _M_psort.delall ();
  }


  // sortiert Eintrge
  void exsort (KEYP __A[])
  {
    //_U_mu_union wert;
    KEYP k;

    for (unsigned int x = 0; x < _M_anz; x++)
      {
	k = __A[x];

//cerr << "exsort: hi=" << (int)k._M_key.s.hi << " lo=" << (int)k._M_key.s.lo << " i=" << (int)k._M_key.i << endl;
//cerr << "exsort  k =" << (int) k._M_key.i << endl;
//cerr << "exsort A[]=" << (int) __A[x]._M_key.i << endl;


	k._M_key.s.hi++;
	_M_hisort.hafset (k._M_key.s.hi, k._M_key.s.hi);
	(_M_psort.haget (k._M_key.s.lo))->fastinsert (k);
	//_M_hisort.haset (k._M_key.s.hi, k._M_key.s.hi);
	//(_M_psort.haget (k._M_key.s.lo))->insert (k);    
      }
  }

  // liest ersten Eintrag aus dem Array
  KEYP getfirst ()
  {
    bool sl;
    KEYP ret;

    _M_subidx = _M_hiidx = _M_loidx = 0;

    while (_M_hiidx < DEFSIZE)
      {
	if ((_M_xhi = _M_hisort.haget (_M_hiidx)))
	  {
	    _M_loidx = 0;
	    ret = searchlo (&sl);

	    if (sl)
	      {
		//cerr << " searchlo hi=" << _M_hiidx << endl;
		return ret;
	      }
	  }

	_M_hiidx++;
      }

//cerr << " searchlo hi=nixgefunden!\n";

    return ret;
  }

// liest nchsten Eintrag aus dem Array
  KEYP getnext ()
  {
    KEYP ret;
    bool sl;

    if (_M_loidx < DEFSIZE)
      {
	ret = searchlo (&sl);

	if (sl)
	  {
	    return ret;
	  }
      }

    while (_M_hiidx < DEFSIZE)
      {
	_M_hiidx++;

	if ((_M_xhi = _M_hisort.haget (_M_hiidx)))
	  {
	    _M_loidx = 0;
	    ret = searchlo (&sl);

	    if (sl)
	      {
		return ret;
	      }
	  }
      }

    return ret;
  }


protected:

  void getidx (unsigned int &__loidx, unsigned int &__subidx)
  {
    __loidx = _M_loidx;
    __subidx = _M_subidx;
  }

private:

  KEYP searchlo (bool * __ok)
  {
    ENDLISTEP *el;
    KEYP ret;

    while (_M_loidx < DEFSIZE)
      {
	if ((el = _M_psort.haget (_M_loidx)))
	  {
	    ret = el->getfirst ();

//     cerr << " testgetnext first: " << ret._M_key.s.hi << " : " << _M_xhi << endl;  
	    if (ret._M_key.s.hi == _M_xhi)
	      {
		ret._M_key.s.lo = _M_loidx;
		ret._M_key.s.hi = _M_xhi - 1;

		_M_loidx++;
		*__ok = true;
		return ret;
	      }

	    while (el->getnext (&ret))
	      {
//       cerr << " testgetnext next: " << ret._M_key.s.hi << " : " << _M_xhi << endl;
		if (ret._M_key.s.hi == _M_xhi)
		  {
		    ret._M_key.s.lo = _M_loidx;
		    ret._M_key.s.hi = _M_xhi - 1;

		    _M_loidx++;
		    *__ok = true;
		    return ret;
		  }
	      }
	  }
	_M_loidx++;
      }

    ret = 0;
    *__ok = false;

//cerr << "searchlo: nix gefunden!\n";

    return ret;
  }

// ndere DEFSIZE fr Statische Klassen
// ganz wichtig, vor include der hash.h DEFSIZE auf 0xffff setzen !!!
  HISORT _M_hisort;		// Erste Sortierung
  PSORT _M_psort;		// Letzte Sortierung mit Listen

  unsigned int _M_anz;

  unsigned short _M_xhi;
  unsigned int _M_hiidx, _M_loidx, _M_subidx, _M_subanz;
};

#undef HISORT
#undef KEYP
#undef PSORT
#undef ENDLISTEP

// Strings sortieren
// Maximaler Zahlenwert fr die Caracters
#define MAXW  0xff
#define MAXA  MAXW+1

// Baut Arrays in der Lnge von 256
// Denkbar ist auch ein Sortierverfahren welches mit Arrays von einer
// Lnge von 0xffff+1 hat. Wrde aber viel mehr Speicher verschwenden
// 
class hstrsort:public harray < hstrsort * >
{

public:
  hstrsort (unsigned short __anz):harray < hstrsort * >(MAXA)
  {
    _M_anz = __anz;
    _M_iscnt = 0;
    _M_ispos = 0;
  }

   ~hstrsort ()
  {
    // allocierten Speicher freigeben
    delall ();
  }

  // Array of Char *
  void exsort (const char **__s)
  {
    for (unsigned short x = 0; x < _M_anz; x++)
      {
	insertstr (0, __s[x]);
      }
  }

  // gibt ein Array von Strings zurck
  // o mu mallocierter Speicher sein !!!
  void getall (char **o)
  {
    unsigned short strline = 0;
    getstrings (strline, o);
  }

private:

  hstrsort (unsigned short __anz,
	    unsigned short __dim):harray < hstrsort * >(MAXA)
  {
    _M_anz = __anz;
    _M_iscnt = 0;
    _M_ispos = __dim;
  }

  // sucht rekursiv den String
  void getstrings (unsigned short &__strnum, char **__mr)
  {
    unsigned short x;
    hstrsort *hstr;

    // war String zuende ?
    for (x = _M_iscnt; x > 0; x--)
      {
	__mr[__strnum][_M_ispos] = 0;

	//if ( __strnum >= (_M_anz-1))
	//return;
	if (!(__strnum >= (_M_anz - 1)))
	  strcpy (__mr[__strnum + 1], __mr[__strnum]);

	__strnum++;
      }

    // gehen weitere Strings ab ?
    for (x = 0; x < MAXA; x++)
      if ((hstr = haget (x)))
	{
	  __mr[__strnum][_M_ispos] = x;
	  hstr->getstrings (__strnum, __mr);
	}
  }

  void insertstr (unsigned short __pos, const char *__s)
  {
    char x;
    hstrsort *hstr;

    x = __s[__pos];

    // char ist gltig, es geht weiter
    if (x)
      {
	// gehe weiter
	hstr = haget (x);

	// falls nix, neu machen
	if (!hstr)
	  {
	    hstr = new hstrsort (_M_anz, _M_ispos + 1);
	    haset (x, hstr);
	  }

	hstr->insertstr (__pos + 1, __s);
      }
    else
      {
	// fertig
	_M_iscnt++;
      }

  }

  unsigned short _M_iscnt, _M_anz, _M_ispos;
};

#undef MAXW
#undef MAXA



// ab jetzt braucht man es nicht mehr
#undef DEFSIZE
#undef SUBASIZE

#endif
