/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 */



#include <unistd.h>
#include "hash.hh"


// Anzahl der Daten im Hash
#define  ANZ  0x8f

// Sleep Zeit um anderen Prozessen etwas Rechenzeit zu geben
#define ZSLEEP 200


int erroranz, schleifen;


typedef unsigned long unsl;

int
main (int argc, char *argv[])
{
  unsigned char a;
  short *p, x, y;
  long i;
  errorenum e;
  larray < short *>*liste;
  laperror err;

  //    data        keystruct, hier nicht verwendet
  xdhashchar < short *, char >hh;


  // lese das Argument
  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  erroranz = 0;

  // Auf gehts...
  for (i = 0; i < schleifen; i++)
    {

      cout << "\ninsert: " << ANZ << " items: ";
      usleep (ZSLEEP);


      // Fge Daten ein
      for (a = 0; a < ANZ; a++)
	{

	  p = new short (-a - 1);

	  if ((e = hh.insert (a, p)))	// key , data
	    {
	      erroranz++;
	      err.str (e, "es wird nicht eingefgt");
	    }
	  else
	    cout << *p << " ";
	}
      cout << "\n*** Fehleranzahl ist:" << erroranz << "!, " << "Schleife " <<
	i << " Super! ***\n";
      if (erroranz)
	exit (-1);

      usleep (ZSLEEP);


      // Teste die Suchfunktion, die wichtigste
      // Funktion des Hashes !
      cout << "\nfinde: ";
      for (a = 0; a < ANZ; a++)
	{
	  hh.search (&p, a, &e);

	  if (p)
	    {
	      cout << *p << "  ";

	      // geht nicht bei null
	      if (-a - 1 != *p)
		erroranz++;

	      if (erroranz)
		{
		  cout << " Error Key=" << (int) a << " Data=" << *p << endl;
		  exit (-1);
		}

	    }
	  else
	    erroranz++;
	}

      cout << "\n*** Fehleranzahl ist:" << erroranz << "!, " << "Schleife " <<
	i << " Super! ***\n";
      if (erroranz)
	exit (-1);


      cout << endl << "iteriere: ";


      // die Funktion getall gibt eine Liste zurck,
      // sollten Zeiger auf die Daten sein.
      liste = new larray < short *>(ANZ + 3);

      // getall iteriert durch den Hash und gibt
      // in einer Liste die Daten / Zeiger zurck.
      // Das ist bei dem Rekursiven aufbau des
      // Hashes gnstiger als fr jeden einzelnen
      // Eintrag einzeln wieder in die Tiefe zu gehen
      hh.getall (liste, &e);


      if (liste)
	{
	  x = *liste->getfirst ();

	  cout << "f: " << x << "\n";

	  // berprfe gleich mit der Suchfunktion
	  usleep (ZSLEEP);


	  while (liste->isnext ())
	    {

	      //y = *liste->getnext ();
	      liste->getnext (p);
	      y = *p;

	      cout << "l: " << y << " ";

	      if (y != x - 1)
		erroranz++;

	      if (erroranz)
		{
		  cout << " Error! " << " x=" << x << " y=" << y << endl;
		}

	      x = y;
	    }

	}
      else
	{
	  erroranz++;
	}

      cout << "\n*** Fehleranzahl ist:" << erroranz << "!, " << "Schleife " <<
	i << " Super! ***\n";
      if (erroranz)
	exit (-1);

      // entferne die Liste wieder
      liste->destroyall ();
      delete liste;

      cout << endl;


      cout << endl << "delete: ";
      e = NOOK;

      usleep (ZSLEEP);
      // Speicher wieder freigeben
      for (a = 0; a < ANZ; a++)
	{

	  hh.destroy (a, &e);

	  cout << (int) a << " ";
	  if (e != ISOK)
	    {
	      erroranz++;
	    }
	}

      cout << "\n*** Fehleranzahl ist:" << erroranz << "!, " <<
	"Schleife " << i << " Super! ***\n";

      usleep (500);

      if (erroranz)
	{
	  exit (-1);
	}
    }


  return 0;
}
