/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 */


#include <unistd.h>
#include "hash.hh"

int errornum, schleifen;

int
main (int argc, char *argv[])
{
  int x, *y;
  int z;
  long i;
  hfifo < int *>fifo (20);	// ein FIFO mu gengend Platz haben


  if (argc < 2)
    {
      cerr << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  // lese den Parameter ein 
  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  for (i = 0; i < schleifen; i++)
    {
      cerr << "push: ";

      // int erzeugen und in fifo Pushen
      for (x = 0; x < 18; x++)
	{
	  y = new int (x);
	  fifo.push (y);
	  cerr << *y << " ";
	}

      // sind auch alle drinn?
      z = fifo.getcnt ();
      cerr << "getcnt = " << z << "\n";

      if (z != 18)
	errornum++;


      // auch beim pullen sollte die Anzahl stimmen, nicht max berschreiten !
      cerr << "pull: ";
      for (x = 0; x < 18; x++)
	{
	  y = fifo.pull ();
	  if (y)
	    cerr << *y << " ";
	  // delete y;
	}

      // jetzt sollte alles wieder leer sein
      z = fifo.getcnt ();
      cerr << "getcnt = " << z << "\n";

      if (z != 0)
	errornum++;


      cerr << "*** Errornum = " << errornum << " *** " << "durchlauf: "
	<< i << " ***\n";

      // alle Daten freigeben,
      // es mu sichergestellt sein das die Daten nicht vorher freigegeben worden
      // sind!
      fifo.delall ();

      cerr << "push: ";


      // eine Testreihe, berprft die Reihenfolge
      fifo.push (y = new int (27));
      cerr << *y << " ";
      fifo.push (y = new int (28));
      cerr << *y << " ";
      fifo.push (y = new int (29));
      cerr << *y << " ";
      z = fifo.getcnt ();
      cerr << "getcnt = " << z << "\n";
      if (z != 3)
	errornum++;


      y = fifo.pull ();
      if (*y != 27)
	errornum++;
      delete y;

      y = fifo.pull ();
      if (*y != 28)
	errornum++;
      delete y;

      y = fifo.pull ();
      if (*y != 29)
	errornum++;
      delete y;

      // jetzt ist wieder alles null!
      z = fifo.getcnt ();
      cerr << "getcnt = " << z << "\n";
      if (z != 0)
	errornum++;



      fifo.push (y = new int (17));
      //cerr << "push: " << *y << "\n";
      fifo.push (y = new int (18));
      //cerr << "push: " << *y << "\n";
      fifo.push (y = new int (19));
      //cerr << "push: " << *y << "\n";

      // wir holen die Anzahl
      z = fifo.getcnt ();
      if (z != 3)
	errornum++;


      //cerr << "getcnt = " << z << "\n";
      cerr << "pull ";
      // jetzt holen wir soviel wie wir vorher
      // mit getcnt bekommen haben
      for (x = 0; x < z; x++)
	{
	  y = fifo.pull ();
	  cerr << *y << " ";
	  delete y;
	}
      cerr << "\n";

      // jetzt sollte alles wieder null sein
      z = fifo.getcnt ();
      cerr << "getcnt = " << z << "\n";
      if (z != 0)
	errornum++;


      // es sind 20 definiert, man steht etwa bei 18 also noch 18  dazu "berfhrt" den fifo
      fifo.resize (21);
      cerr << "push resize: ";
      for (x = 0; x < 21; x++)
	{
	  y = new int (x);
	  fifo.push (y);
	  cerr << *y << " ";
	}

      z = fifo.getcnt ();
      cerr << " getcnt = " << z << "\n";
      if (z != 21)
	errornum++;


      // auch beim pullen sollte die Anzahl stimmen, nicht max berschreiten !
      cerr << "pull: ";
      for (x = 0; x < 21; x++)
	{
	  y = fifo.pull ();

	  if (*y != x)
	    errornum++;

	  if (y)
	    cerr << *y << " ";

	  delete y;
	}


      // und wieder alles null
      z = fifo.getcnt ();
      cerr << "\ngetcnt = " << z << "\n";
      if (z != 0)
	errornum++;


      cerr << "*** Errornum = " << errornum << " *** " << "durchlauf: "
	<< i << " ***\n";

      if (errornum)
	exit (-1);

      usleep (500);

    }

  return 0;
}
