/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *
 */


//#include "math.h"
#include "hash.hh"

#include <unistd.h>



// Eintrge im Hash


#ifdef MEMTEST
// therwise the storage requirement becomes too highly
#define  ANZ  0x3ff
#else
#define  ANZ  0x3ffff
#endif

// Zufallszahlengenerator
int
random (int bereich)
{
  return (int) (((float) rand () / (float) RAND_MAX) *
		(float) (bereich - 1) + 1.5);
}


int erroranz, schleifen;

// Wartezeit
#define U 20

void
check (int key, int data)
{
  if ((key + 100) != data)
    {
      erroranz++;
      cout << "Error, key=" << key << " data=" << data << "\n";
    }

}

void
check200 (int key, int data)
{
  if ((key + 200) != data)
    {
      erroranz++;
      cout << "Error, key=" << key << " data=" << data << "\n";
    }
}

int
main (int argc, char *argv[])
{
  int a, r, *p, y, keymax, *adr;
  long i;
  errorenum e;

  laperror err;


  //    data   key
  hhash < int *, int >hh (ANZ);


  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  erroranz = 0;

  cout << "*** insert " << ANZ << " items ***\n";
  usleep (U);


  cout << "*** Teste gefirst() auf leere Hash! ***\n";
  r = 0;
  p = hh.getfirst (&r);
  if (p)
    {
      cerr << "getfirst auf leere Hash liefert Zeiger !\n";
      exit (-1);
    }


  cout << "*** Fehleranzahl ist:" << erroranz << "!, Super! ***\n";


  for (a = 1; a <= ANZ; a++)
    {				// bin nice zu allen anderen

      r = random (ANZ);
      // Zufallszahlen einfgen
      p = new int (r + 100);
      if ((e = hh.update (r, p)))	// key , data
	{
	  erroranz++;
//        err.str (e, "es wird nicht eingefgt");
	}
      keymax = a;
    }


  cout << "*** Fehleranzahl ist:" << erroranz << "!, Super! ***\n";

  for (i = 0; i < schleifen; i++)
    {

      usleep (U);
      cout << "*** suche " << ANZ << " items ***\n";
      for (a = 1; a <= ANZ; a++)
	{			// bin nice zu allen anderen
	  y = random (ANZ);

//  cout << "s key=" << y << " ";

	  // Suche zufllig nach Schlssel
	  hh.search (&p, y, &e);

	  if (p)
	    {
//            cout << " .";
	      check (y, *p);
	    }
	  else
	    {
//            err.str (e, " x");
	    }
	}

      cout << endl;
      cout << "*** Fehleranzahl ist:" << erroranz << "!, Super! ***\n";

      cout << "*** lsche " << ANZ / 2 << " items ***\n";

      // nicht jeder Compiler kann halt

#ifdef WATCOM
      p = new int[ANZ + 1];
      for (y = 0; y < ANZ; y++)
	p[y] = 0;
#else
#ifdef PPC
      p = new int[ANZ + 1];
      for (y = 0; y < ANZ; y++)
	p[y] = 0;
#else
      p = new int[ANZ + 1] (0);
#endif
#endif

      if (!p)
	{
	  cerr << "nicht gengend Speicher fr p!\n";
	  exit (-1);
	}

      int ok, b;
      for (a = 1; a <= ANZ / 2; a++)
	{			// bin nice zu allen anderen
	  // setze Key mit Zufallszahl

	  adr = NULL;

	  //while (!adr)
	  for (b = 0; b < 3; b++)
	    {
	      y = p[a] = random (ANZ);
	      hh.search (&adr, p[a], &e);
	      if (adr)
		break;
	    }

//        cout << "lsche key=" << y;

	  // lsche Key
#ifdef WATCOM
	  if ((e = hh.destroy (y)))
#else
	  if ((e = hh.destroy (y, HFREE)))
#endif
	    {
	      //      cout << "fehler beim destroy, vermutlich member nicht vorhanden!\n";

	      hh.search (&adr, y, &e);

	      if (adr)
		ok = false;
	      else
		ok = true;

	      // war nicht gelscht, also Fehler 
	      if (!ok)
		erroranz++;
	    }
	  // Errorausgabe
	  //err.str (e, "kann nicht lschen");
	}


      cout << "*** Ende, Fehleranzahl ist:" << erroranz << "!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}

      // Suchen und Ausgeben der noch vorhandenen Mitglieder
      cout << "*** suche " << ANZ << " items ***\n";
      for (a = 1; a <= ANZ; a++)
	{			// bin nice zu allen anderen
	  y = random (ANZ);

//        cout << "suche key=" << y << " ";

	  e = NULLERROR;
	  adr = NULL;
	  hh.search (&adr, y, &e);

	  if (adr)
	    {
//    cout << " gefunden! key=" << y << " number=" << *adr << "\n";
	      check (y, *adr);
	    }
	}

      cout << "*** Ende suche , Fehleranzahl ist:" << erroranz <<
	"!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}


      // wieder Einfgen der gelschten Werte
      cout << "*** wieder einfgen ***\n";

      for (a = 1; a <= ANZ / 2; a++)
	{			// bin nice zu allen anderen
	  b = p[a];

	  if (b)
	    {
	      adr = new int (b + 100);
	      if ((e = hh.insertuni (b, adr)))	// key , data
		{
		  // ist kein Fehler      
		  //erroranz++;
		  // err.str (e, "es wird nicht eingefgt, vermutlich Key doppelt");
		}
	      //    cout << "key: " << b << "versucht einzufgen\n";
	    }
	}

      cout << "*** Ende wieder einfgen, Fehleranzahl ist:" << erroranz <<
	"!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}


      // suchen und finden der gelschten/wieder eingefgten members
      cout << "*** suche wieder " << ANZ << " items ***\n";
      for (a = 1; a <= ANZ / 2; a++)
	{			// bin nice zu allen anderen
	  y = p[a];		//random (ANZ);

//        cout << "suche key=" << y << " ";

	  e = NULLERROR;
	  adr = NULL;
	  hh.search (&adr, y, &e);

	  if (adr)
	    {
	      //    cout << " gefunden! key=" << y << " number=" << *adr << "\n";
	      check (y, *adr);
	    }
	  else
	    {
//            err.str (e, "nicht gefunden");
	      erroranz++;
	    }
	}

      cout << "*** Ende, Fehleranzahl ist:" << erroranz << "!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}


      // Auflisten des gesamten Hashs
      cout << "\n*** durchsuche den gesamten Hash! ***\n";
      adr = hh.getfirst (&a);
      r = 1;

      if (adr)
	{
	  cout << " getfirst =" << *adr << " key=" << a << endl;
	  // geht nur weil adr==NULL sicher das Ende ist, ansonsten
	  // mte e auf NIXKEY geprft werden
	  while ((adr = hh.getnext (&a, &e)))
	    {
	      r++;
	      //      cout << " getnext =" << *adr << " k=" << a << endl;
	    }
	}
      else
	{
	  cout << "Error: getfirst ist fehlgeschlagen!\n";
	  erroranz++;
	}
      // von vorn
      usleep (U);


      cout << endl << "*** Fehleranzahl (durchsuchen) ist:" << erroranz <<
	"!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}

      cout << "*** delete " << ANZ << " items ***\n";


      /*
         // in einer For Schleife durch den Hash
         for (adr = hh.getfirst (&a); adr; adr = hh.getnext (&a, &e))
         {
         if (hh.destroy(a))
         {
         cerr << "kann nicht lschen!?\n";
         erroranz++;
         }                                                                                                  
         }
       */

      // noch einfacher!!!
      hh.delall ();


      cout << endl << "*** Fehleranzahl (delete) ist:" << erroranz <<
	"!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}

      cout << "*** beginne delete test...\n";


      for (a = 1; a <= ANZ; a++)
	{			// bin nice zu allen anderen
	  // Suche zufllig nach Schlssel
	  hh.search (&p, a, &e);

	  if (p)
	    {
	      //     cout << " Error key=" << a << " gefunden" << endl;
	      erroranz++;
	    }
	}

      cout << endl << "*** Fehleranzahl (delete test) ist:" << erroranz <<
	"!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}


      cout << "*** updates " << ANZ << " items ***\n";

      adr = new int (22);
      for (a = 1; a <= ANZ; a++)
	{
	  if ((e = hh.insert (a, adr)))
	    erroranz++;
	}

      cout << endl << "*** Fehleranzahl (insert) ist:" << erroranz <<
	"!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}


      for (a = 1; a <= ANZ; a++)
	{
	  // Zufallszahlen einfgen
	  // aber die vorigen Zeiger hngen in der Luft !!!!
	  p = new int (a + 200);

	  if ((e = hh.update (a, p)))	// key , data
	    {
	      erroranz++;
//            err.str (e, "es wird nicht eingefgt");
	    }
	  keymax = a;
	}

      cout << endl << "*** Fehleranzahl (update) ist:" << erroranz <<
	"!, Super! ***\n";

      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}


      for (a = 1; a <= ANZ; a++)
	{			// bin nice zu allen anderen
	  y = random (ANZ);

//        cout << "key=" << y << " ";

	  // Suche zufllig nach Schlssel
	  hh.search (&p, y, &e);

	  if (p)
	    {
//            cout << " .";
	      check200 (y, *p);
	    }
	  else
	    {
	      //      err.str (e, " x");
	    }
	}

      cout << endl << "*** Fehleranzahl (check200) ist:" << erroranz <<
	"!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}


      cout << "*** updates wieder lschen! " << ANZ << " items ***\n";


      // alle lschen
      for (a = 1; a <= ANZ; a++)
	{
#ifdef WATCOM
	  if (hh.destroy (a))
#else
	  if (hh.destroy (a, HFREE))
#endif
	    erroranz++;

//        cerr << "key=" << a << " ";
	}

      cout << "*** Fehleranzahl destroy ist:" << erroranz <<
	"!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}


      for (a = 1; a <= ANZ; a++)
	{
	  // Zufallszahlen einfgen
	  // aber die vorigen Zeiger hngen in der Luft !!!!
	  p = new int (a + 100);

	  if ((e = hh.update (a, p)))	// key , data
	    {
	      erroranz++;
//            err.str (e, "es wird nicht eingefgt");
	    }
	  keymax = a;
	}

      delete adr;		// wieder freigeben

      cout << "*** Fehleranzahl freigabe ist:" << erroranz <<
	"!, Super! ***\n";
      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}

      cout << "*** Ende, Fehleranzahl ist:" << erroranz << "!, Super! ***\n";

      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}

    }

  return 0;
}
