// Sortierungsgeschwindigkeit testen

#include <stdio.h>


// geht nicht bei der Gre
#ifdef MEMTEST
#undef MEMTEST
#endif

// wegen dem Statischen Member  65536
#define DEFSIZE (0xffff +1)
#include "../hash/hash.hh"

#include <unistd.h>
#include <time.h>

// Klasse zum sortieren
intsortarray *sarray;

// Ausgaben
int verbose;

// ### fr hsort ###

// Array ausgeben
void
ausgabearray (unsigned int anz)
{
  cout << " " << sarray->getfirst ();

  for (unsigned int x = 1; x < anz; x++)
    {
      cout << " " << sarray->getnext ();
    }

  cout << endl;
}



// #########  Zufallszahlengenerator  ############
void
initarray (unsigned int anz, unsigned int *a)
{
  unsigned int x;
  for (x = 0; x < anz; x++)
    a[x] = rand ();		// keine Nullen, kann ja bei der Ausgabe korrigiert werden -1 !!!
}


void
ausgabe (unsigned int anz, unsigned int *a)
{
  unsigned int x;

  for (x = 0; x < anz; x++)
    {
      cout << " " << a[x];
    }

  cout << endl;
}


// ##################### fr qsort ########################
unsigned int
qpart (unsigned int *A, unsigned int v, unsigned int b)
{
  unsigned int x;
  int i, j;

  x = A[v];
  i = v - 1;
  j = b + 1;

  while (1)
    {
      do
	j--;
      while (!(A[j] <= x));

      do
	i++;
      while (!(A[i] >= x));

      // Sortorder kann nicht gendert werden da sonst die Suchfunktion nicht geht
      if (i < j)
	{
	  // ist Gleichschnell aber schner!
	  A[i] ^= A[j];
	  A[j] ^= A[i];
	  A[i] ^= A[j];
	}
      else
	{
	  return j;
	}
    }
}

void
shfqsort (unsigned int *A, unsigned int v, unsigned int b)
{
  unsigned int q;

  if (v < b)
    {
      q = qpart (A, v, b);
      shfqsort (A, v, q);
      shfqsort (A, q + 1, b);
    }
}

void
hfqsort (unsigned int *A, unsigned int l)
{
  shfqsort (A, 0, l - 1);	// Array Grenzen 
}

// #######################################################################

void
execqsort (unsigned int anz, unsigned int *a)
{
  // Standart Implementation
  hfqsort (a, anz);
}


int
testesort (unsigned int anz, unsigned int *a)
{
  bool err = false;
  unsigned int x, al;

  al = sarray->getfirst ();

  for (x = 0; x < anz; x++)
    {
      if (a[x] != al)
	{
	  err = 255;
	  fprintf (stderr, "Fehler bei: %3d q=0x%08x a=0x%08x\n", x, a[x],
		   al);

	}
      al = sarray->getnext ();
    }

  cout << endl;

  return err;
}

// ############ Mehrfachtests ############################

clock_t
exhsort (int l, unsigned int anz, unsigned int *a)
{
  int x, loanz;
  clock_t ha, he, hd;

  hd = 0;

  //loanz = 500;                        // anz / 10000 * 30 + 0xf;
  loanz = 300;

  for (x = 0; x < l; x++)
    {
      sarray = new intsortarray (anz, loanz);

      ha = clock ();
      sarray->exsort (a);
      he = clock ();

      hd += he - ha;

      if (x < l - 1)		// letzte bleibt !!!
	delete sarray;
    }

  return hd / l;
}

clock_t
exqsort (int l, unsigned int anz, unsigned int *a, unsigned int *b)
{
  int x;
  clock_t ha, he, hd;

  hd = 0;

  for (x = 0; x < l; x++)
    {
      memcpy (a, b, anz * sizeof (unsigned int));

      ha = clock ();
      execqsort (anz, a);
      he = clock ();

      hd += he - ha;
    }

  return hd / l;
}


// teste sort
int
main (int argc, char *argv[])
{
  unsigned int *a, *b;
  int e, x, loops;
  float prozent;
  FILE *rdev;
  bool rc;
  clock_t hq, hd;

  unsigned long anz, anzeige;	// Anzahl der Zahlen

  anz = 0xff;
  verbose = rc = false;
  e = 0;
  loops = 1;
  anzeige = 10;

  // lese das Argument #################
  if (argc < 2)
    {
    hilfe:
      cout << "Bitte geben Sie die Anzahl der Values an!\n";
      cout << "hsort [-vN|-VN] [-h|?] [-aN] [-lN] [-c|-sX] \n";
      cout << "v = Verbose Anzeigeanzahl N\n";
      cout << "a = Anzahl der zu sortierenden Zahlen N\n";
      cout << "c = Konstante Zufallszahlen, default srand(/dev/random)\n";
      cout << "s X, Setze die Zufallszahlenreihe srand(X)\n";
      cout << "l = Schleifen, wieoft wird sortiert, default 1\n";
      return -1;
    }

  for (e = 1; e != 0;)
    {
      switch ((x = getopt (argc, argv, "v:V:a:b:l:s:ch?")))
	{
	case 's':
	  e = atol (optarg);
	  srand (e);
	  cout << "Setze Zufallszahlen auf=" << e << endl;
	  rc = true;
	  break;
	case 'c':
	  rc = true;
	  cout << "Konstante Zufallszahlen!\n";
	  break;
	case 'v':
	  verbose = true;
	  cout << "Verbose = 1\n";
	  anzeige = atol (optarg);
	  break;
	case 'V':
	  cout << "Verbose = 2\n";
	  verbose = 2;
	  anzeige = atol (optarg);
	  break;
	case 'h':
	case '?':
	  goto hilfe;
	  break;
	case 'a':
	  anz = atol (optarg);
	  break;
	case 'l':
	  loops = atol (optarg);
	  break;
	case -1:
	  e = 0;
	  break;
	}
    }

  a = new unsigned int[anz];
  b = new unsigned int[anz];

  sarray = NULL;		//new hsarray (anz, 0xffff, 0xf);

  if (!rc)
    {
      rdev = NULL;
      rdev = fopen ("/dev/random", "r");

      if (rdev)
	{
	  fread (&e, sizeof (int), 1, rdev);
	  srand (e);
	}
    }

  e = 0;

  if (a)
    {
      if (verbose)
	cout << "Init Array, Anz=" << anz << endl;

      initarray (anz, a);

      memcpy (b, a, anz * sizeof (unsigned int));

      if (verbose)
	{
	  cout << "Ausgabe der ersten Zahlen: \n";
	  ausgabe (anzeige, a);
	  cout << "Sortiere Hsort...\n";
	}

      hd = exhsort (loops, anz, a);

      if (verbose)
	{
	  cout << "Diff: " << hd << endl;
	  cout << "Ausgabe der ersten sortierten Zahlen: \n";
	  ausgabearray (anzeige);
	  cout << "Sortiere Qsort...\n";
	}

      hq = exqsort (loops, anz, a, b);

      if (verbose)
	{
	  cout << "Diff: " << hq << endl;
	  cout << "Ausgabe der ersten sortierten Zahlen: \n";
	  ausgabe (anzeige, a);
	}


      e = testesort (anzeige, a);
      cout << "Ergebniss:\n";
      cout << "Errors: " << e << " !\n";
      cout << "Zeit qsort: " << hq << endl;
      cout << "Zeit hsort: " << hd << endl;

      prozent = 100.0 - (100.0 * hd) / (float) hq;
      printf ("%2.1f Prozent schneller!!!\n", prozent);
    }
  else
    {
      cerr << "Konnte nicht gengend " << anz << " Integer mallocen!\n";
    }

  return e;
}
