/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *
 */


#include <unistd.h>
#include "hash.hh"

#define  ANZ  30


#define SCHLEIFEN 10000

int
random (unsigned int bereich)
{
  return (int) (((float) rand () / (float) RAND_MAX) *
		(float) (bereich - 1) + 1.5);
}


int erroranz;


typedef unsigned long unsl;


typedef struct Teststruct
{
  unsigned int a, b, c;
}
tstr;



int
main (int argc, char *argv[])
{
  unsl i;
  //errorenum e;
  laperror err;
  unsigned int x;

  tstr kstr;

  //    data        keystruct, hier nicht verwendet
  xdhashlong < int *, tstr * >hhl;
  xdhashint < int *, tstr * >hhi;
  xdhashshort < int *, tstr * >hhs;
  xdhashchar < int *, tstr * >hhc;

  erroranz = 0;

  // Lnge der Typen mal ausgeben
  cout << "Typensize long=" << sizeof (long) <<
    " int=" << sizeof (int) <<
    " short=" << sizeof (short) << " char=" << sizeof (char) << " !\n";

  // Wir bilden mal aus 3 Integern eine Key mit der createkey Funktion
  // die in jeder Hash vorhanden ist

  for (x = 0; x < 256; x++)
    printf ("Nr: %02d  Char:%c\n", x, x);

  // ******** Long *****************************************+
  for (i = 0; i < 4; i++)
    {
      kstr.a = random (0xffffffff);
      kstr.b = random (0xffffffff);
      kstr.c = random (0xffffffff);

      x = 0;
      x = hhl.createkey (&kstr, sizeof (unsigned int) * 3);

      //cout << "key aus a=" << kstr.a << " b=" << kstr.b << " c=" << kstr.c << " ist=";
      fprintf (stdout, "key long aus a=%x b=%x c=%x keyt=%x\n", kstr.a,
	       kstr.b, kstr.c, x);

    }

  kstr.a = 0xffffffff;
  kstr.b = 0xffffffff;
  kstr.c = 0xffffffff;

  x = 0;
  x = hhl.createkey (&kstr, sizeof (unsigned int) * 3);

  //cout << "key aus a=" << kstr.a << " b=" << kstr.b << " c=" << kstr.c << " ist=";
  fprintf (stdout, "key long aus a=%x b=%x c=%x keyt=%x\n", kstr.a, kstr.b,
	   kstr.c, x);


  // Gebe mal ein paar Key's aus, mit allen verschiedenen
  // Hashtypen

  // ********* Integer ****************************
  for (i = 0; i < 4; i++)
    {
      kstr.a = random (0xfffffff);
      kstr.b = random (0xfffffff);
      kstr.c = random (0xfffffff);

      x = 0;
      x = hhi.createkey (&kstr, sizeof (unsigned int) * 3);

      //cout << "key aus a=" << kstr.a << " b=" << kstr.b << " c=" << kstr.c << " ist=";
      fprintf (stdout, "key int aus a=%x b=%x c=%x keyt=%x\n", kstr.a, kstr.b,
	       kstr.c, x);

    }
  kstr.a = 0xffffffff;
  kstr.b = 0xffffffff;
  kstr.c = 0xffffffff;

  x = 0;
  x = hhi.createkey (&kstr, sizeof (unsigned int) * 3);

  //cout << "key aus a=" << kstr.a << " b=" << kstr.b << " c=" << kstr.c << " ist=";
  fprintf (stdout, "key int aus a=%x b=%x c=%x keyt=%x\n", kstr.a, kstr.b,
	   kstr.c, x);

  // ****** Short ******************************
  for (i = 0; i < 4; i++)
    {
      kstr.a = random (0xffff);
      kstr.b = random (0xffff);
      kstr.c = random (0xffff);

      x = 0;
      x = hhs.createkey (&kstr, sizeof (unsigned int) * 3);

      //cout << "key aus a=" << kstr.a << " b=" << kstr.b << " c=" << kstr.c << " ist=";
      fprintf (stdout, "key short aus a=%x b=%x c=%x keyt=%x\n", kstr.a,
	       kstr.b, kstr.c, x);
    }

  kstr.a = 0xffff;
  kstr.b = 0xffff;
  kstr.c = 0xffff;

  x = 0;
  x = hhs.createkey (&kstr, sizeof (unsigned char) * 3);

  //cout << "key aus a=" << kstr.a << " b=" << kstr.b << " c=" << kstr.c << " ist=";
  fprintf (stdout, "key short aus a=%x b=%x c=%x keyt=%x\n", kstr.a, kstr.b,
	   kstr.c, x);

  // ****** Char ******************************
  for (i = 0; i < 4; i++)
    {
      kstr.a = random (0xff);
      kstr.b = random (0xff);
      kstr.c = random (0xff);

      x = 0;
      x = hhc.createkey (&kstr, sizeof (unsigned int) * 3);

      //cout << "key aus a=" << kstr.a << " b=" << kstr.b << " c=" << kstr.c << " ist=";
      fprintf (stdout, "key char aus a=%x b=%x c=%x keyt=%x\n", kstr.a,
	       kstr.b, kstr.c, x);
    }


  kstr.a = 0xff;
  kstr.b = 0xff;
  kstr.c = 0xff;

  x = 0;
  x = hhc.createkey (&kstr, sizeof (unsigned char) * 3);

  //cout << "key aus a=" << kstr.a << " b=" << kstr.b << " c=" << kstr.c << " ist=";
  fprintf (stdout, "key char aus a=%x b=%x c=%x keyt=%x\n", kstr.a, kstr.b,
	   kstr.c, x);



  return 0;
}
