/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *
 */


#include "hash.hh"

#include <unistd.h>



int errornum, schleifen;


int
main (int argc, char *argv[])
{
  larray < int *>al (15);
  unsigned int x;
  int *y, a, b;

  errornum = 0;


  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  for (long i = 0; i < schleifen; i++)
    {
      cout << "Definierte 9 !\n";


      for (x = 0; x < 9; x++)
	{
	  y = new int (x);

	  al.insert (y);
	}



      // Teste getfirst
      cout << "Getfirst = " << (a = *(int *) al.getfirst ()) << "\n";
      // Teste getlast
      cout << "GetLast = " << (b = *(int *) al.getlast ()) << "\n";

      if (a == 0 && b == 8)
	{
	  cout << "OK\n";
	}
      else
	{
	  errornum++;
	}




      // Teste getfirst, Datensatzzeiger verstellen
      cout << "Getfirst = " << (a = *(int *) al.getfirst ()) << "\n";

      for (x = 9; x < 17; x++)
	{
	  y = new int (x);

	  al.insertlast (y);	// Insertlast testen
	}

      // Teste getfirst
      cout << "Getfirst = " << (a = *(int *) al.getfirst ()) << "\n";
      // Teste getlast
      cout << "GetLast = " << (b = *(int *) al.getlast ()) << "\n";

      if (a == 0 && b == 16)
	{
	  cout << "OK\n";
	}
      else
	{
	  errornum++;
	}

      cout << ".";



      // Teste getnext
      cout << (a = *(int *) al.getfirst ()) << " ";
      while (al.isnext ())
	{
	  al.getnext (y);

	  cout << (b = *y) << " ";

	  if (b != (a + 1))
	    errornum++;

	  a = b;
	}
      cout << "\n";


      cout << "*** Erronum 1 =" << errornum << "***\n";


      // Teste getringnext
      cout << ".";

      cout << (a = *(int *) al.getfirst ()) << " ";
      for (x = 0; x < 25; x++)
	{
	  y = al.getringnext ();

	  cout << (b = *y) << " ";

	  if (x == 16)
	    {
	      if (b != 0)
		errornum++;
	    }
	  else
	    {
	      if (b != (a + 1))
		errornum++;
	    }
	  a = b;

	}

      cout << "*** Erronum 2 =" << errornum << "***\n";
      cout << ".";

      // Teste getprev
      cout << (a = *(int *) al.getlast ()) << " ";
      while (al.isprev ())
	{
	  al.getprev (y);
	  cout << (b = *y) << " ";

	  if (b != (a - 1))
	    errornum++;

	  a = b;


	}

      cout << "*** Erronum 3 =" << errornum << "***\n";
      cout << ".";

      // Teste getringprev
      cout << (a = *(int *) al.getlast ()) << " ";

      for (x = 0; x < 25; x++)
	{
	  cout << (b = *(int *) al.getringprev ()) << " ";

	  if (x == 16)
	    {
	      if (b != 16)
		errornum++;
	    }
	  else
	    {
	      if (b != (a - 1))
		errornum++;
	    }
	  a = b;
	}


      cout << "*** Erronum 4 =" << errornum << "***\n";
      cout << ".";

      // Test selektor
      for (x = 0; x < 17; x++)
	{
	  al.setselektor ((unsigned) x);
	  cout << (a = *(int *) al.getselektor (x)) << " ";

	  if (a)
	    {
	      if (b != (a - 1))
		errornum++;
	    }
	  b = a;
	}

      cout << "*** Erronum 5 =" << errornum << "***\n";
      cout << ".";

      // Test lschen
      // Test lschen 3,15 und 16!
      al.delselektor (3);
      al.delselektor (4);
      al.delselektor (15);
      al.delselektor (16);


      al.setselektor (3);
      if (al.getselektor (x))
	errornum++;		// sollte wirklich NULL sein

      al.setselektor (4);
      if (al.getselektor (x))
	errornum++;		// sollte wirklich NULL sein

      al.setselektor (15);
      if (al.getselektor (x))
	errornum++;		// sollte wirklich NULL sein

      al.setselektor (16);
      if (al.getselektor (x))
	errornum++;		// sollte wirklich NULL sein

      //  Teste getnext!
      y = (int *) al.getfirst ();

      if (y)
	cout << *y << " ";

      while (al.isnext ())
	{
	  al.getnext (y);
	  //y = (int *) al.getnext ();
	  if (y)
	    cout << *y << " ";
	}

      cout << "*** Erronum 6 (while) =" << errornum << "***\n";
      cout << ".";


      // Zustzlich teste getakt fr die for Schleifen

      // isnext geht nur bei mehreren!?
      /*
         for (y = (int *) al.getfirst (); al.isakt (); al.getnext (y))
         {
         if (y)
         cout << *y << " ";
         }


         cout << "*** Erronum 6 (for) =" << errornum << "***\n";
         cout << ".";
       */


#ifndef WATCOM
      al.pack ();		// gelschte wieder zusammenpacken, seht sparsam verwenden !!!
#endif

      // testen ob das Packen geklappt hat
      y = (int *) al.getfirst ();
      cout << (a = *y) << " ";

      while (al.isnext ())
	{
	  al.getnext (y);

	  if (y)
	    {
	      cerr << "y=" << y << endl;
	      b = *y;

	      //y = (int *) al.getnext ();
	      cout << b << " ";

	      if (a)
		{
		  if (b != (a - 1))
		    errornum++;
		}
	      b = a;
	    }
	  else
	    {
	      cerr <<
		"Pack geht nicht!, warscheinlich mit WATCOM compiliert!\n";
	    }


	}

      cout << "*** Erronum 7 =" << errornum << "***\n";
      cout << ".";



      // "Expand Pos 3 Size 2!\n";
      // aufspreizen des Arrays, auch sehr sparsam verwenden !!!
      al.expand (3, 2);		// Position und Anzahl


      y = new int (15);
      al.insert (y);
      y = new int (16);
      al.insert (y);


      // testen ob das Packen geklappt hat
      y = (int *) al.getfirst ();
      if (y)
	cout << "Ausgabe 8: " << *y << " ";
      while (al.isnext ())
	{
	  al.getnext (y);
	  //y = (int *) al.getnext ();
	  if (y)
	    {
	      cout << *y << " ";
	    }
	  else
	    {
	      cout << "0 ";
#ifndef WATCOM
	      errornum++;
#else
	      cerr << "WATCOM Error!\n";
#endif
	    }
	}


      if (*(int *) (al.getselektor (3)) != 15)
	errornum++;		// sollte wirklich NULL sein

      if (*(int *) (al.getselektor (4)) != 16)
	errornum++;		// sollte wirklich NULL sein

      cout << "*** Erronum 8 = " << errornum << "***\n";

      // alle lschen
      al.delall ();

      // Test mit insertlast einzufgen
      for (x = 0; x < 17; x++)
	{
	  y = (int *) al.getlast ();

	  y = new int (x);
	  al.insertlast (y);

	  cout << "insert:" << *y << endl;
	}


      // Zum Test alles lesen
      a = *al.getfirst ();
      if (a != 0)
	errornum++;

      cout << "get:" << a << endl;

      while (al.isnext ())
	{
	  //a = *(int *) al.getnext ();
	  al.getnext (y);
	  a = *y;
	  cout << "get:" << a << endl;

	  if (a - 1 != b)
	    errornum++;

	  b = a;
	}
      cout << "*** Erronum 9 insertlast =" << errornum << "***\n";


      al.delall ();

      for (x = 0; x < 17; x++)
	{
	  y = (int *) al.getselektor (x);

	  if (y)
	    {
	      errornum++;
	      cout << "Nummer x=" << x << " wurde nicht gelscht!\n";
	    }
	}

      cout << "*** Erronum 10 =" << errornum << "***\n";
      cout << ".";

      if (errornum)
	exit (-1);


      cout << "\n*** Durchlauf = " << i << " ***\n";

      // nice zu anderen Prozessen
      usleep (500);

    }


  return 0;
}
