



#include <unistd.h>
#include <unistd.h>
#include <time.h>


#include "hash.hh"

#define MAXLOOP 255

#define MIN(A, B)  A<B?A:B

int
random (unsigned int bereich)
{
  return (int) (((float) rand () / (float) RAND_MAX) *
		(float) (bereich - 1) + 1.5);
}

int
my_memcmp_stdlib (void *a, void *b, size_t x)
{
  return memcmp (a, b, x);
}

int
main ()
{
  uchar error;

  cerr << "ulong: " << sizeof (ulong) << endl;
  cerr << "uint: " << sizeof (uint) << endl;
  cerr << "ushort: " << sizeof (ushort) << endl;
  cerr << "uchar: " << sizeof (uchar) << endl;

  char *a = "qwertzuiop+";
  char *b = "qwertzuiop+";

  error = 0;
  if (memcmp_int (a, b, strlen (a)))
    {
      cerr << a << " == " << b << endl;
    }
  else
    {
      cerr << a << " != " << b << "Error" << endl;
      error++;
    }

  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }

  char *a2 = "1wertzuiop+as";
  char *b2 = "1wertzuiop+as";

  if (memcmp_int (a2, b2, strlen (a2)))
    {
      cerr << a2 << " == " << b2 << endl;
    }
  else
    {
      cerr << a2 << " != " << b2 << "Error" << endl;
      error++;
    }


  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }
  char *a3 = "2wertzuiop+asd";
  char *b3 = "2wertzuiop+asd";


  if (memcmp_int (a3, b3, strlen (a3)))
    {
      cerr << a3 << " == " << b3 << endl;
    }
  else
    {
      cerr << a3 << " != " << b3 << "Error" << endl;
      error++;
    }

  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }

  char *a32 = "2wertzuiop+asd";
  char *b32 = "2wertzuiop+asx";


  if (memcmp_int (a32, b32, strlen (a32)))
    {
      cerr << a32 << " == " << b32 << "Error" << endl;
      error++;
    }
  else
    {
      cerr << a32 << " != " << b32 << endl;
    }

  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }

  char *a31 = "2wertzuiop+asd1";
  char *b31 = "2wertzuiop+asd2";


  if (memcmp_int (a31, b31, strlen (a31)))
    {
      cerr << a31 << " == " << b31 << "Error" << endl;
      error++;
    }
  else
    {
      cerr << a31 << " != " << b31 << endl;
    }

  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }
  char *a7 = "2wertzu";
  char *b7 = "2wertzu";
  if (memcmp_int (a7, b7, strlen (a7)))
    {
      cerr << a7 << " == " << b7 << endl;
    }
  else
    {
      cerr << a7 << " != " << b7 << "Error" << endl;
      error++;
    }

  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }
  char *a71 = "2wertzu";
  char *b71 = "2wertzU";
  if (memcmp_int (a71, b71, strlen (a71)))
    {
      cerr << a71 << " == " << b71 << "Error" << endl;
      error++;
    }
  else
    {
      cerr << a71 << " != " << b71 << endl;
    }

  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }

  // Random tests !!
  char r1[255], r2[255];
  uns x;

  for (x = 0; x < MAXLOOP; x++)
    {
      sprintf (r1, "%d mein teststring %d", random (0xff),
	       random (0xffffffff));
      sprintf (r2, "%d mein teststring %d", random (0xff),
	       random (0xffffffff) + 1);

      if (memcmp_int (r1, r2, MIN (strlen (r1), strlen (r2))))
	{
	  cerr << r1 << " == " << r2 << "Error" << endl;
	  error++;
	}
      else
	{
	  cerr << r1 << " != " << r2 << endl;
	}
    }

  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }
  for (x = 0; x < MAXLOOP; x++)
    {
      sprintf (r1, "%d mein teststring %d", random (0xff),
	       random (0xffffffff));
      strcpy (r2, r1);

      if (memcmp_int (r1, r2, MIN (strlen (r1), strlen (r2))))
	{
	  cerr << r1 << " == " << r2 << endl;
	}
      else
	{
	  cerr << r1 << " != " << r2 << "Error:" <<
	    (MIN (strlen (r1), strlen (r2))) % sizeof (uint) << endl;
	  error++;
	}
    }

  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }

  cerr << "Test Laenge!\n";

  clock_t ha, he;
  uint y;

#define TIMEANZ 61000
#define FORMATSTR "%dfhdsafds,.-,-fsda-fds8i321482394712faadffsasafdjksalkfreouirezoqwpowpo%d"
  ha = clock ();
  for (x = 1; x < TIMEANZ; x++)
    {
      sprintf (r1, FORMATSTR, random (0xff), random (0xffffffff));
      strcpy (r2, r1);

      //cerr << "test: " << r2 << endl;
      y = MIN (x, 200);
      r1[y] = r2[y] = 0;

      if (memcmp_int (r1, r2, MIN (y, strlen (r1))))
	{
	  //cerr << r1 << " == " << r2 << endl;
	}
      else
	{
	  cerr << r1 << " != " << r2 << "Error!" << endl;
	  error++;
	}
      if (error)
	{
	  cerr << "Error!\n";
	  return 1;
	}
    }
  he = clock ();

  cerr << "Zeit = " << he - ha << endl;


  ha = clock ();
  for (x = 1; x < TIMEANZ; x++)
    {
      sprintf (r1, FORMATSTR, random (0xff), random (0xffffffff));
      strcpy (r2, r1);

      //cerr << "test: " << r2 << endl;

      y = MIN (x, 200);
      r1[y] = r2[y] = 0;

      if (!my_memcmp_stdlib (r1, r2, MIN (y, strlen (r1))))
	{
	  //cerr << r1 << " == " << r2 << endl;
	}
      else
	{
	  cerr << r1 << " != " << r2 << "Error!" << endl;
	  error++;
	}
      if (error)
	{
	  cerr << "Error!\n";
	  return 1;
	}
    }
  he = clock ();

  cerr << "Zeit = " << he - ha << endl;

  if (error)
    {
      cerr << "Error!\n";
      return 1;
    }

  // Testzeilen um die Speicherberwachung zu testen

  /*
     int * mti = new int[2];
     cerr << "Fehler: test1!!!\n";
     mti[2] = 27;
     delete mti;
     cerr << "Fehler: test2!!!\n";
     mti[1] = 27;
   */


#ifdef MEMTEST
  cerr << "OK! MEMTEST!\n";
#else
  cerr << "OK!\n";
#endif

  return 0;
}
