/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *
 */


#include "hash.hh"

//#include "stdlib.h"
#include <unistd.h>


// Anzahl der Elemente die sortiert werden sollen
#define ANZAHL 20


// Zufallszahlengenerator
int
random (int bereich)
{
  return (int) (((float) rand () / (float) RAND_MAX) *
		(float) (bereich - 1) + 1.5);
}



int
main (int argc, char *argv[])
{
  int x, i, schleifen;

  // hqsort sortiert Arrays vom Type "keydata"
  keydata < int, int >*kd[ANZAHL];

  // eine Instanz von qsort
  hqsort < int, int >q;

  // Parameter bergeben ?
  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  // also eine Schleife sollte es mindestens sein!
  if (schleifen <= 0)
    return -1;

  // erzeuge ein Array von Pointer die auf "keydata" Zeigen
  for (x = 0; x < ANZAHL; x++)
    {
      kd[x] = new keydata < int, int >;
    }

  for (i = 0; i < schleifen; i++)
    {

      // Schreibe Zufallszahlen in die Liste
      for (x = 0; x < ANZAHL; x++)
	{
	  kd[x]->_M_key = random (ANZAHL);
	  kd[x]->_M_data = kd[x]->_M_key;
	}

      // Ausgabe
      /*
         for (x = 0; x < ANZAHL; x++)
         {
         cout << "x=" << x << " key=" << kd[x]->key << " data=" << kd[x]->data << "\n";
         }
       */
      // Sortiere den Haufen
      q.qsort (kd, ANZAHL - 1);

      // bin nice zu allen anderen
      usleep (500);

      cout << "#" << i << "\t";

      // Fehlerberprfung und alles Ausgeben
      for (x = 0; x < ANZAHL - 1; x++)
	{
	  if (kd[x]->_M_key <= kd[x + 1]->_M_key)
	    {
#ifdef DEBUG
	      cout << "x=" << x << " key=" << kd[x]->_M_key << " data=" <<
		kd[x]->_M_data << "\n";
#else
	      cout << ".";
#endif
	    }
	  else
	    {
	      cout << "Error !";
	      cout << "x=" << x << " k=" << kd[x]->_M_key << " d=" <<
		kd[x]->_M_data << "\n";

	      exit (-1);
	    }

	}

      cout << "\n";

    }

  cout << "Fertig ohne Fehler !!! :-)) \n";

  return 0;
}
