/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *
 */


#include "hash.hh"

#include <unistd.h>



int errornum, schleifen;


#define TESTANZ  100000

// Listenlnge
#define LANZ  1123

int
main (int argc, char *argv[])
{
  rliste < int *>rl;
  int x, *y, *z, a, b;
  errornum = 0;


  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  for (long i = 0; i < schleifen; i++)
    {
      cout << "Definierte " << LANZ << "!\n";

      rl.delall ();

      // von vorn beginnen
      for (x = 0; x < LANZ; x++)
	{
	  y = new int (x);
	  if (rl.insertlast (y))
	    errornum++;
	}

      cout << "*** Erronum 1 insertlast() =" << errornum << "***\n";

      // Teste getfirst
      cout << "Getfirst = " << (a = *(int *) rl.getfirst ()) << "\n";
      // Teste getlast
      cout << "GetLast = " << (b = *(int *) rl.getlast ()) << "\n";

      // Teste erstes und letztes
      if (a == 0 && b == LANZ - 1)
	{
	  cout << "OK\n";
	}
      else
	{
	  errornum++;
	}

      cout << "*** Erronum 2 test =" << errornum << "***\n";
      if (errornum)
	exit (-1);

      // insert testen
      for (y = rl.getfirst (); rl.isakt (); y = rl.getnext ())
	{
	  z = new int (-*y);

	  if (rl.insert (z))	// fgt an aktueller Stelle ein
	    errornum++;

	  cout << "z=" << *z << " ";
	}
      cout << "\n*** Erronum 3 inset() =" << errornum << "***\n";
      if (errornum)
	exit (-1);

      // ausgeben
      for (a = b = 0, y = rl.getfirst (); rl.isakt (); y = rl.getnext (), b++)
	{
	  if (a != *y)
	    errornum++;

	  cout << " y=" << *y << " ";

	  if (b % 2)
	    {
	      if (a < 0)
		a = -a;
	      a++;
	    }
	  else
	    a = -a;
	}

      cout << "\n*** Erronum 4 test() =" << errornum << "***\n";
      if (errornum)
	exit (-1);


      // Teste getringnext
      b = 0, y = rl.getfirst ();
      while (1)
	{
	  cout << " r=" << *y << " ";

	  if (++b > LANZ * 2 + 20)
	    break;

	  y = rl.getringnext ();
	}

      if (b < LANZ * 2 + 20)
	errornum++;
      cout << "\n*** Erronum 5 getringnext, ausgabe() =" << errornum <<
	"***\n";
      if (errornum)
	exit (-1);

      // Teste getringprev
      b = 0, y = rl.getlast ();
      while (1)
	{
	  cout << " r=" << *y << " ";

	  if (++b > LANZ * 2 + 20)
	    break;

	  y = rl.getringprev ();
	}

      if (b < LANZ * 2 + 20)
	errornum++;
      cout << "\n*** Erronum 6 getringprev, ausgabe() =" << errornum <<
	"***\n";
      if (errornum)
	exit (-1);

      rl.delall ();

      // erzeuge 1 Element

      y = new int (1);
      if (rl.insertlast (y))
	errornum++;

      // ausgeben und lschen
      y = rl.getfirst ();

      cerr << "Erstes Element =" << *y << endl;

      // lschen
      rl.delakt ();

      // ausgeben und lschen
      y = rl.getfirst ();

      if (y)
	errornum++;
      cout << "\n*** Erronum 7 einzelnes lschen, ausgabe() =" << errornum <<
	"***\n";
      if (errornum)
	exit (-1);

      y = new int (1);
      if (rl.insertlast (y))
	errornum++;
      y = new int (2);
      if (rl.insertlast (y))
	errornum++;


      // ausgeben und lschen
      y = rl.getlast ();

      cerr << "Letztes Element =" << *y << endl;

      // lschen
      rl.delakt ();

      // ausgeben und lschen
      y = rl.getlast ();

      cerr << "Letztes Element =" << *y << endl;

      if (*y != 1)
	errornum++;
      cout << "\n*** Erronum 8 letztes lschen, ausgabe() =" << errornum <<
	"***\n";
      if (errornum)
	exit (-1);

      y = new int (2);
      if (rl.insertlast (y))
	errornum++;
      y = new int (2);
      if (rl.insertlast (y))
	errornum++;
      y = new int (3);
      if (rl.insertlast (y))
	errornum++;


      // ausgeben und lschen
      for (y = rl.getfirst (); rl.isakt (); y = rl.getnext ())
	{
	  cerr << "y=" << *y << endl;
	}

      cerr << "2. Element lschen!" << endl;

      // 2. Element lschen
      y = rl.getfirst ();
      cerr << "getfirst!=" << *y << endl;
      y = rl.getnext ();
      cerr << "getnext!=" << *y << endl;
      y = rl.delakt ();
      cerr << "akt=" << *y << endl;

      // ausgeben und lschen
      for (a = 1, y = rl.getfirst (); rl.isakt (); y = rl.getnext (), a++)
	{
	  cerr << "y=" << *y << endl;
	  if (a != *y)
	    errornum++;
	}

      cout << "\n*** Erronum 9 mittleres lschen, ausgabe() =" << errornum <<
	"***\n";
      if (errornum)
	exit (-1);
      // von vorn beginnen
      rl.delall ();


    }


  return 0;
}
