/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *
 */


#include <unistd.h>
#include "hash.hh"

#define ANZTEST 100000

int errornum;


int
main (int argc, char *argv[])
{
  int a, b, schleifen;
  errorenum ok;
  long i;			// fr Schleife


#ifdef WATCOM

  // der Watcom ist einfach zu bld
  cout << "Demoprogramm kann nicht compiliert werden! Watcom ist zu bld!\n";
  return 0;

#else

  // Beide Objekte, salist enthlt keydata zum sortieren.
  salist < int, int >*sa;
  keydata < int, int >*sx;


  sa = new salist < int, int >(15);

  // Lese den Parameter ein
  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  // gehe die Schleifen durch
  for (i = 0; i < schleifen; i++)
    {

      // generiere die Zahlen von 14 bis 0
      for (a = 14; a >= 0; a--)
	{
	  sa->insert (a, a + 100);	// key , data
	}


      // Stimmt auch alles ?
      cout << "Listenelement: ";
      //for (sx = sa->getfirst (); sx; sx = sa->getnext ())
      for (sx = sa->getfirst (); sa->getnext (sx);)
	{
	  cout << " d=" << sx->_M_data << " k=" << sx->_M_key << " ";
	  if (sx->_M_key > 0)
	    {
	      if (sx->_M_data - 100 != sx->_M_key)
		{
		  errornum++;
		}
	    }
	}
      cout << "\n";
      cout << "*** Errornum = " << errornum << " *** " << "durchlauf: "
	<< i << " ***\n";


      // und jetzt sortiere
      cout << "Sort mit qsort!\n";
      sa->sort ();

      cout << "Listenelement: ";

      // stimmt jetzt alles ?
      for (b = a = 0, sx = sa->getfirst (); sa->getnext (sx);)
	{
	  cout << "d=" << sx->_M_data << " ";
	  b = sx->_M_data;

	  if (a > b)
	    if (sx->_M_key)
	      errornum++;

	  a = b;
	}
      cout << "\n";
      cout << "*** Errornum = " << errornum << " *** " << "durchlauf: "
	<< i << " ***\n";


      // suche Einzelflle!
      cout << "Starte Suchfunktion!\n";
      b = 7;
      cout << "gefunden key=" << b << " data=" << (a =
						   sa->bsearch (b,
								&ok)) << "\n";
      if (a != b + 100)
	errornum++;


      b = 5;
      cout << "gefunden key=" << b << " data=" << (a =
						   sa->bsearch (b,
								&ok)) << "\n";
      if (a != b + 100)
	errornum++;

      // 0 key ist Kennung fr gelschte Daten
      b = 0;
      cout << "gefunden key=" << b << " data=" << (a =
						   sa->bsearch (b,
								&ok)) << "\n";
      if (a != 0)
	errornum++;

      b = 14;
      cout << "gefunden key=" << b << " data=" << (a =
						   sa->bsearch (b,
								&ok)) << "\n";
      if (a != b + 100)
	errornum++;

      cout << "*** Errornum = " << errornum << " *** " << "durchlauf: "
	<< i << " ***\n";

      cout << "Starte Lschen!\n";

      b = 3;
      sa->destroy (b);
      cout << "Lsche " << b << "\n";

      for (sx = sa->getfirst (); sa->getnext (sx);)
	{
	  //cout << "Listenelement: data=" << sx->data << " key=" << sx->key << "\n";
	  if (sx->_M_data == 103)
	    errornum++;
	}

      b = 1;
      sa->destroy (b);
      cout << "Lsche " << b << "\n";
// sa->sort();
      for (sx = sa->getfirst (); sa->getnext (sx);)
	{
	  //cout << "Listenelement: data=" << sx->data << " key=" << sx->key << "\n";
	  if (sx->_M_data == 101)
	    errornum++;
	}

//sa->sort();

      b = 27;
      if (sa->destroy (b))
	cout << "Fehler beim Lschen, key nicht gefunden!\n";
      cout << "Lsche " << b << "\n";
      for (sx = sa->getfirst (); sa->getnext (sx);)
	{
	  //cout << "Listenelement: data=" << sx->data << " key=" << sx->key << "\n";
	  if (sx->_M_data == 127)
	    errornum++;
	}

      b = 14;
      if (sa->destroy (b))
	cout << "Fehler beim Lschen, key nicht gefunden!\n";
      cout << "Lsche " << b << "\n";
      for (sx = sa->getfirst (); sa->getnext (sx);)
	{
	  //cout << "Listenelement: data=" << sx->data << " key=" << sx->key << "\n";
	  if (sx->_M_data == 114)
	    errornum++;
	}

      // fge wieder einzelne ein
      cout << "\n Inserttest!\n";
      sa->insert (27, 127);
      sa->insert (37, 128);
      sa->insert (47, 129);
      sa->insert (48, 129);
      sa->insert (49, 129);

      errornum += 5;

      cout << "Listenelement: ";
      for (sx = sa->getfirst (); sa->getnext (sx);)
	{
	  cout << "d=" << sx->_M_data << " k=" << sx->_M_key << " ";

	  if (sx->_M_data == 127)
	    errornum--;
	  if (sx->_M_data == 128)
	    errornum--;
	  if (sx->_M_key == 47)
	    errornum--;
	  if (sx->_M_key == 48)
	    errornum--;
	  if (sx->_M_key == 49)
	    errornum--;

	}

      cout << "\n";

      // alle lschen fr nchste Runde
      for (b = 0; b < 50; b++)
	{
	  sa->destroy (b);
	}
      cout << "\n";

      cout << "*** Errornum = " << errornum << " *** " << "durchlauf: "
	<< i << " ***\n";

      if (errornum)
	exit (-1);

      usleep (500);

    }

#endif

  return 0;
}
