/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *
 */


#include "hash.hh"

#include <unistd.h>

// Anzahl der Integer 
#define ANZ  0xefa

// Hash Listenanzahl
#define SIZE 0xfa


int erroranz, schleifen;

// Wartezeit
#define U 20

int
main (int argc, char *argv[])
{
  int a, *p, keymax;
  long i;
  errorenum e;

  laperror err;

  //     Size   , data 
  smhash < SIZE, int *>sh;

  // liste fr die Rckgabe der gesamten Hash, unsigned int ist immer der Key
  rliste < keydata < int *, unsigned >*>lp;
  keydata < int *, unsigned >*kd;


  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  erroranz = 0;



  for (i = 0; i < schleifen; i++)
    {
      cout << "*** insert " << ANZ << " items ***\n";
      usleep (U);

      for (a = 1; a <= ANZ; a++)
	{			// bin nice zu allen anderen

	  p = new int (a + 100);

	  cerr << " " << *p;

	  if ((e = sh.insert (a, p)))	// key , data
	    {
	      erroranz++;
	    }
	  keymax = a;
	}


      cout << "*** Fehleranzahl ist:" << erroranz << "!, Super! ***\n";


      usleep (U);
      cout << "*** suche " << ANZ << " items ***\n";
      for (a = 1; a <= ANZ; a++)
	{			// bin nice zu allen anderen

	  // Suche zufllig nach Schlssel
	  sh.search (&p, a, &e);

	  if (p)
	    {
	      cerr << " " << *p;
	      if (*p != a + 100)
		erroranz++;
	    }
	}

      cout << endl;
      cout << "*** Fehleranzahl ist:" << erroranz << "!, Super! ***\n";

      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}



      usleep (U);
      cerr << "*** insertuni " << 4 << " items ***\n";

      p = new int (121212);
      if ((e = sh.insertuni (*p, p)))	// key , data
	{
	  erroranz++;
	}

      p = new int (212121);
      if ((e = sh.insertuni (*p, p)))	// key , data
	{
	  erroranz++;
	}

      p = new int (313131);
      if ((e = sh.insertuni (*p, p)))	// key , data
	{
	  erroranz++;
	}

      p = new int (131313);
      // sollte nur einmal eingefgt werden!
      if ((e = sh.insertuni (*p, p)))	// key , data
	{
	  erroranz++;
	}

      if ((e = sh.insertuni (*p, p)) == NIXKEY)	// key , data
	{
	  cerr << "Ist OK, insertuni nur einmal eingefgt!";
	}
      else
	erroranz++;

      if ((e = sh.insertuni (*p, p)) == NIXKEY)	// key , data
	{
	  cerr << "Ist OK, insertuni nur einmal eingefgt!";
	}
      else
	erroranz++;

      usleep (U);
      cerr << "*** insertuni wieder suchen ***\n";


      sh.search (&p, 121212, &e);
      if (p)
	{
	  cerr << " " << *p;
	  if (*p != 121212)
	    erroranz++;
	}
      sh.search (&p, 212121, &e);
      if (p)
	{
	  cerr << " " << *p;
	  if (*p != 212121)
	    erroranz++;
	}
      sh.search (&p, 131313, &e);
      if (p)
	{
	  cerr << " " << *p;
	  if (*p != 131313)
	    erroranz++;
	}
      sh.search (&p, 313131, &e);
      if (p)
	{
	  cerr << " " << *p;
	  if (*p != 313131)
	    erroranz++;
	}

      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}
      cout << endl;
      cout << "*** Fehleranzahl ist:" << erroranz << "!, Super! ***\n";



      // Teste Funktion Update
      usleep (U);
      cerr << "*** insertuni " << 4 << " items ***\n";


      p = new int (111);
      // sollte nur einmal eingefgt werden!
      if ((e = sh.update (131313, p)))	// key , data
	{
	  erroranz++;
	}

      // wieder finden
      sh.search (&p, 131313, &e);
      if (p)
	{
	  cerr << " " << *p;
	  if (*p != 111)
	    erroranz++;
	}


      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}
      cout << endl;
      cout << "*** Fehleranzahl insertuni ist:" << erroranz <<
	"!, Super! ***\n";


      // Teste Funktion destroy
      usleep (U);
      cerr << "*** destroy " << 4 << " items ***\n";


      cout << "destroy: 131313\n";
      sh.destroy (131313, HFREE);

      // wieder finden
      p = NULL;
      sh.search (&p, 131313, &e);
      if (p && e == ISOK)
	{
	  cerr << " gefunden: " << *p;
	  erroranz++;
	}


      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}
      cout << endl;
      cout << "*** Fehleranzahl destroy hfree ist:" << erroranz <<
	"!, Super! ***\n";


      // destroy ohne hfree  
      usleep (U);
      cerr << "*** destroy ohne hfree ***\n";

      p = new int (111);
      // sollte nur einmal eingefgt werden!
      if ((e = sh.update (131313, p)))	// key , data
	{
	  erroranz++;
	}


      cout << "destroy: 131313\n";
      sh.destroy (131313, HNOFREE);

      // selber frei geben
      delete p;

      // wieder finden
      p = NULL;
      sh.search (&p, 131313, &e);
      if (p && e == ISOK)
	{
	  cerr << " gefunden: " << *p;
	  erroranz++;
	}

      if (erroranz)
	{
	  cout << "Errors = " << erroranz << "!\n";
	  exit (-1);
	}
      cout << endl;
      cout << "*** Fehleranzahl destroy nofree ist:" << erroranz <<
	"!, Super! ***\n";

      // Doppeleinfgungen testen, es ist beim smh auch mglich Werte doppelt einzutragen.
      // Das ist sinnvoll falls die Schlsselgenerierung mal nicht korrekt arbeitet
      usleep (U);
      cerr << "*** Doppeleinfgung testen ***\n";

      p = new int (311);
      // sollte nur einmal eingefgt werden!
      if ((e = sh.insert (111, p)))	// key , data
	{
	  erroranz++;
	}

      p = new int (411);
      // sollte nur einmal eingefgt werden!
      if ((e = sh.insert (111, p)))	// key , data
	{
	  erroranz++;
	}

      p = new int (511);
      // sollte nur einmal eingefgt werden!
      if ((e = sh.insert (111, p)))	// key , data
	{
	  erroranz++;
	}

      p = new int (611);
      // sollte nur einmal eingefgt werden!
      if ((e = sh.insert (111, p)))	// key , data
	{
	  erroranz++;
	}

      p = new int (711);
      // sollte nur einmal eingefgt werden!
      if ((e = sh.insert (111, p)))	// key , data
	{
	  erroranz++;
	}

      // wieder finden
      p = NULL;
      sh.search (&p, 111, &e);
      if (p && e == ISOK)
	{
	  cerr << " erstmal gefunden: " << *p << endl;

	}
      else
	erroranz++;

      p = NULL;

      a = 211;

      // doppelte suchen
      while (sh.searchdoppel (&p, &e))
	{
	  if (p)
	    cerr << "doppelt gefunden: " << *p << endl;

	  if ((a += 100) != *p)
	    erroranz++;
	}

      // Teste Iterator
      sh.getall (&lp);

      int ai = 0;


      for (kd = lp.getfirst (); lp.isakt (); kd = lp.getnext ())
	{
	  cerr << " " << *kd->_M_data;
	  ai++;
	}

      // ohne die Member zu lschen, das tut der hash !
      lp.destroyall ();

      cerr << "*** hash iterator! Schleife = " << i << " ***\n";

      // teste iteratior
      int ax = 0;
      for (kd = sh.smgetfirst (); kd; kd = sh.smgetnext ())
	{
	  cerr << " " << *kd->_M_data;
	  ax++;
	}

      if (ai != ax)
	{
	  cerr << "*** Fehler: Iteratoren unterschiedlich ! " << ai << " != "
	    << ax << " ***\n";
	  return 1;
	}
      else
	cerr << "*** OK: Iteratoren gleich! " << ai << " == " << ax <<
	  " ***\n";


      usleep (U);
      cerr << "*** delall() fr nchste Runde! Schleife = " << i << " ***\n";

      // alles wieder lschen
      sh.delall ();
    }

  usleep (U);
  cerr << "*** smh Fertig! ***\n";


  return 0;
}
