/*
 * Test und Dokumentationsprogramm zur hash.h
 * Test and documentation program for hash.h
 *
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *            Do which you want with it
 */


#include "hash.hh"
#include <unistd.h>

// Anzahl der Integer 
// Number of integer
#define ANZ  50

// number of list size
#define SIZE 0xf

//char *FORMATSTR = "der xx key %d, ng";
#define FORMATSTR "der xx key %d, ng"

#define STRSIZE sizeof(FORMATSTR)+10

int erroranz, schleifen;

// waittime
#define U 20

int
main (int argc, char *argv[])
{
  //     Size   , data 
  smhasheed < SIZE, unsigned *>sh;
  keyclass < unsigned *>*keycp;
  unsigned *u;
  unsigned ckey;
  unsigned z;
  char *string;
  errorenum e;

  if (argc < 2)
    {
      cout << "please you indicate the number of loops!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  erroranz = 0;


  for (int i = 0; i < schleifen; i++)
    {
      cout << "*** insert " << ANZ << " items ***\n";
      usleep (U);

      cerr << endl << "insert: ";

      for (unsigned a = 1; a <= ANZ; a++)
	{			// bin nice zu allen anderen
	  u = new unsigned (a);
	  string = new char[STRSIZE];
	  sprintf (string, FORMATSTR, a);

	  cerr << string << ":" << *u << ":";

	  // erzeuge eindeutige Keys !
	  keycp =
	    new keyclass < unsigned *>(freeall, string, strlen (string),
				       &ckey, u);
	  cerr << keycp->getckey () << " ";

	  if ((e = sh.insert (keycp)))
	    {
	      erroranz++;
	    }
	}


      cout << "*** count of errors:" << erroranz << "!, super! ***\n";

      usleep (U);

      if (erroranz)
	{
	  cerr << "*** smh Error! ***\n";
	  usleep (U);
	  return 1;
	}

      cerr << endl << "found no_sec: ";
      // look unique keys up
      for (unsigned a = 1; a <= ANZ; a++)
	{
	  string = new char[STRSIZE];
	  sprintf (string, FORMATSTR, a);

	  keycp =
	    new keyclass < unsigned *>(freekey, string, strlen (string),
				       &ckey);

	  sh.search_nonext (keycp, &e);

	  if (e != ISOK)
	    {
	      erroranz++;
	    }
	  else
	    cerr << ".";

	  if (*keycp->_M_data > ANZ)
	    {
	      erroranz++;
	      cerr << "E:" << keycp->getckey () << " ";
	    }

	  cerr << *keycp->_M_data << " ";

	  delete keycp;
	}

      cout << "*** count of errors:" << erroranz << "!, super! ***\n";

      if (erroranz)
	{
	  cerr << "*** smh Error! ***\n";
	  usleep (U);
	  return 1;
	}

      cerr << endl << "found: ";

      // do look not unique keys up
      for (int a = 1; a <= ANZ; a++)
	{
	  string = new char[STRSIZE];
	  sprintf (string, FORMATSTR, a);

	  keycp = NULL;

	  keycp =
	    new keyclass < unsigned *>(freekey, string, strlen (string),
				       &ckey);

	  if (!keycp)
	    {
	      cerr << "keycp == NULL!" << endl;
	    }

	  if (sh.search (keycp, &e))
	    {
	      z = keycp->_M_data ? *keycp->_M_data : 0;
	      cerr << "Fehler!, " << string << " wert:" << z << endl;
	      erroranz++;
	    }
	  else
	    {
	      z = keycp->_M_data ? *keycp->_M_data : 0;
	      cerr << z << " ok!" << endl;
	    }

	  if (e != ISOK)
	    {
	      erroranz++;
	    }

	  delete keycp;
	}

      cout << "*** count of errors:" << erroranz << "!, super! ***\n";

      if (erroranz)
	{
	  cerr << "*** smh Error! ***\n";
	  usleep (U);
	  return 1;
	}


      // jedes 2. doppelt eintragen !
      // zur Kennung ist der Wert des uns + 100
      for (unsigned a = 1; a <= ANZ; a += 2)
	{			// bin nice zu allen anderen
	  u = new unsigned (a + 100);
	  string = new char[STRSIZE];
	  sprintf (string, FORMATSTR, a);

	  cerr << string << ":" << *u << ":";

	  // erzeuge eindeutige Keys !
	  keycp =
	    new keyclass < unsigned *>(freeall, string, strlen (string),
				       &ckey, u);

	  cerr << keycp->getckey () << " ";

	  if ((e = sh.insert (keycp)))
	    {
	      erroranz++;
	    }
	}

      if (erroranz)
	{
	  cerr << "*** smh Error! ***\n";
	  usleep (U);
	  return 1;
	}

      // look unique keys up
      unsigned einfach, doppelt;

      for (unsigned a = 1; a <= ANZ; a++)
	{
	  string = new char[STRSIZE];
	  sprintf (string, FORMATSTR, a);

	  //ckey = a;
	  keycp =
	    new keyclass < unsigned *>(freekey, string, strlen (string),
				       &ckey);

	  sh.search_nonext (keycp, &e);

	  if (e != ISOK)
	    {
	      erroranz++;
	    }
	  else
	    cerr << ".";

	  //if (*keycp->_M_data != a)
	  z = keycp->_M_data ? *keycp->_M_data : 0;
	  if (z > ANZ)
	    {
	      erroranz++;
	      cerr << "E:" << keycp->getckey () << " ";
	    }

	  z = keycp->_M_data ? *keycp->_M_data : 0;
	  einfach = z;
	  cerr << einfach << " ";

	  // gib doppelten aus !
	  if (sh.search_nonext_next (keycp, &e))
	    {
	      if (e == ISOK)
		{
		  z = keycp->_M_data ? *keycp->_M_data : 0;
		  if (z > ANZ + 100)
		    {
		      erroranz++;
		      cerr << "E:" << keycp->getckey () << " ";
		    }

		  z = keycp->_M_data ? *keycp->_M_data : 0;
		  doppelt = z;
		  cerr << " D:" << doppelt << " ";

		  if (doppelt != einfach + 100)
		    {
		      cerr << "doppelt keyfehler ok!\n";
		    }
		}
	    }

	  delete keycp;
	}

      if (erroranz)
	{
	  cerr << "*** smh Error! ***\n";
	  usleep (U);
	  return 1;
	}

      // suche doppelte ohne Keyfehler !!
      for (unsigned a = 1; a <= ANZ; a++)
	{
	  string = new char[STRSIZE];
	  sprintf (string, FORMATSTR, a);

	  //ckey = a;
	  keycp =
	    new keyclass < unsigned *>(freekey, string, strlen (string),
				       &ckey);

	  sh.search (keycp, &e);

	  if (e != ISOK)
	    {
	      erroranz++;
	    }
	  else
	    cerr << ".";

	  //if (*keycp->_M_data != a)
	  z = keycp->_M_data ? *keycp->_M_data : 0;
	  if (z > ANZ)
	    {
	      erroranz++;
	      cerr << "E:" << keycp->getckey () << " ";
	    }

	  z = keycp->_M_data ? *keycp->_M_data : 0;
	  einfach = z;
	  cerr << einfach << " ";

	  // gib doppelten aus !
	  if (sh.search_next (keycp, &e))
	    {
	      if (*keycp->_M_data > ANZ + 100)
		{
		  erroranz++;
		  cerr << "E:" << keycp->getckey () << " ";
		}

	      z = keycp->_M_data ? *keycp->_M_data : 0;
	      doppelt = z;
	      cerr << " D:" << doppelt << " ";

	      if (doppelt != einfach + 100)
		{
		  cerr << "doppelt keyfehler nook!\n";
		  erroranz++;
		}
	    }

	  delete keycp;
	}

      if (erroranz)
	{
	  cerr << "*** smh Error! ***\n";
	  usleep (U);
	  return 1;
	}

      // delall keydatas !
      sh.delall ();
    }

  // ist berflssig, sollte aber dennoch gehen! delall keydatas !
  //sh.delall ();

  if (erroranz)
    {
      cerr << "*** smh Error! ***\n";
      usleep (U);
      return 1;
    }


  cerr << "*** smh Fertig! OK!!!***\n";
  usleep (U);
  return 0;
}
