// Sortierungsgeschwindigkeit testen

#include <stdio.h>

#include "hash.hh"

#include <unistd.h>
#include <time.h>




// Globaler Zeiger
shortsortarray *csa;





// Ausgaben
int verbose;


// ### fr hsort ###

// Array ausgeben
void
ausgabearray (unsigned int anz)
{
  cout << " " << (int) csa->getfirst ();

  for (unsigned int x = 1; x < anz; x++)
    {
      cout << " " << (int) csa->getnext ();
    }

  cout << endl;
}



// #########  Zufallszahlengenerator  ############
void
initarray (unsigned int anz, unsigned short *a)
{
  unsigned int x;
  for (x = 0; x < anz; x++)
    a[x] = rand ();
}


void
ausgabe (unsigned int anz, unsigned short *a)
{
  unsigned int x;

  for (x = 0; x < anz; x++)
    {
      //cout.form ("0x%08x ", a[x]);
      cout << " " << (int) a[x];
    }

  cout << endl;
}


// ##################### fr qsort ########################
unsigned int
qpart (unsigned short *A, unsigned int v, unsigned int b)
{
  unsigned short x;
  int i, j;
  //int y;

  x = A[v];
  i = v - 1;
  j = b + 1;

  while (1)
    {
      do
	j--;
      while (!(A[j] <= x));

      do
	i++;
      while (!(A[i] >= x));

      // Sortorder kann nicht gendert werden da sonst die Suchfunktion nicht geht
      if (i < j)
	{
	  /*
	     y = A[i];
	     A[i] = A[j];
	     A[j] = y; */

	  // ist Gleichschnell aber schner!
	  A[i] ^= A[j];
	  A[j] ^= A[i];
	  A[i] ^= A[j];
	}
      else
	{
	  return j;
	}
    }
}

void
shfqsort (unsigned short *A, unsigned int v, unsigned int b)
{
  unsigned int q;

  if (v < b)
    {
      q = qpart (A, v, b);
      shfqsort (A, v, q);
      shfqsort (A, q + 1, b);
    }
}

void
hfqsort (unsigned short *A, unsigned int l)
{
  shfqsort (A, 0, l - 1);	// Array Grenzen 
}

// #######################################################################

int
fint (const void *a, const void *b)
{
  return (*(unsigned int *) a > *(unsigned int *) b) ? true : false;
}

void
execqsort (unsigned int anz, unsigned short *a)
{
  //qsort (a, anz, sizeof (unsigned int), fint);
  // Standart Implementation
  hfqsort (a, anz);
}


int
testesort (unsigned int anz, unsigned short *a)
{
  bool err = false;
  unsigned int x;
  unsigned short al;

  al = csa->getfirst ();

  for (x = 0; x < anz; x++)
    {

      if (a[x] != al)
	{
	  err = 255;
	  fprintf (stderr, "Fehler bei: %3d q=0x%08x a=0x%08x\n", x - 1,
		   a[x - 1], al);
	}

      al = csa->getnext ();

    }


  cout << endl;

  return err;
}



// teste sort
int
main (int argc, char *argv[])
{
  unsigned short *a;
  int e, x;

  clock_t qa, qe, ha, he;

  unsigned long anz, anzeige;	// Anzahl der Zahlen

  anz = 0xff;
  verbose = false;
  e = 0;
  anzeige = 10;

  // lese das Argument #################
  if (argc < 2)
    {
    hilfe:
      cout << "Bitte geben Sie die Anzahl der Values an!\n";
      cout << "hsort [-vN|VN ] [-h|?] [-a N ]\n";
      cout << "v = Verbose Anzeigeanzahl N\n";
      cout << "a = Anzahl N\n";
      return -1;
    }

  for (e = 1; e != 0;)
    {
      switch ((x = getopt (argc, argv, "v:V:a:b:h?")))
	{
	case 'v':
	  verbose = true;
	  anzeige = atol (optarg);
	  break;
	case 'V':
	  verbose = 2;
	  anzeige = atol (optarg);
	  break;
	case 'h':
	case '?':
	  goto hilfe;
	  break;
	case 'a':
	  anz = atol (optarg);
	  break;
	case -1:
	  e = 0;
	  break;
	}
    }

  e = 0;
  a = new unsigned short[anz];


  csa = new shortsortarray ();

  if (a)
    {
      if (verbose)
	cout << "Init Array, Anz=" << anz << endl;

      initarray (anz, a);

      if (verbose)
	{
	  cout << "Ausgabe der ersten Zahlen: \n";
	  ausgabe (anzeige, a);
	  cout << "Sortiere Hsort...\n";
	}

      ha = clock ();
      csa->countsort (anz, a);
      he = clock ();

      if (verbose)
	{
	  cout << "a: " << ha << endl;
	  cout << "b: " << he << endl;
	  cout << "Diff: " << he - ha << endl;
	  cout << "Ausgabe der ersten sortierten Zahlen: \n";
	  ausgabearray (anzeige);
	  cout << "Sortiere Qsort...\n";
	}

      qa = clock ();
      execqsort (anz, a);
      qe = clock ();

      if (verbose)
	{
	  cout << "a: " << qa << endl;
	  cout << "b: " << qe << endl;
	  cout << "Diff: " << qe - qa << endl;
	  cout << "Ausgabe der ersten sortierten Zahlen: \n";
	  ausgabe (anzeige, a);
	}



      e = testesort (anzeige, a);
      cout << "Ergebniss:\n";
      cout << "Errors: " << e << " !\n";
      cout << "Zeit qsort: " << qe - qa << endl;
      cout << "Zeit hsort: " << he - ha << endl;

      //delete liste;

    }
  else
    {
      cerr << "Konnte nicht gengend " << anz << " Integer mallocen!\n";
    }

  return e;
}
