/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *
 */



#include <unistd.h>
#include "hash.hh"


#define ANZTEST 100000

int errornum;


// ein ganz normaler Stack
int
main (int argc, char *argv[])
{
  int schleifen, w, x, *y;
  hstack < int *>st (15);	// Stack kann "berfahren" werden
  long z, a, i;

  errornum = 0;

  // lese den Parameter ein
  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  // gehe die Schleifen durch
  for (i = 0; i < schleifen; i++)
    {
      cout << "push: ";
      // Pushe auf den Stack
      for (x = 0; x < 18; x++)
	{
	  y = new int (x);
	  st.push (y);
	  cout << *y << " ";
	}

      // Teste Anzahl 
      z = st.getcnt ();
      if (z != 18)
	errornum++;

      cout << ".";


      // Hole wieder vom Stack runter
      cout << "pop: ";
      for (x = 0, w = z; x < z; x++, w--)
	{
	  y = st.pop ();
	  if (y)
	    cout << *y << " ";

	  // Teste Ergebniss
	  if (*y != w - 1)
	    errornum++;

	}

      // Teste Anzahl
      a = st.getcnt ();
      cout << "\nAnzahl: " << st.getcnt () << "\n";
      if (a != 0)
	errornum++;


      // bei der Verwendung von push und pop wird der Speicherbereich auf dem
      // die Daten zeigen nicht aufgerumt.
      st.delall ();		// Stack aufrumen


      cout << "Wild test: \n";


      // pushd ist ein pushen mit einem delete falls es noch einen
      // element auf der Position gegeben hat

      st.push (y = new int (27));
      cout << "push: " << *y << " ";
      st.push (y = new int (28));
      cout << *y << " ";
      st.push (y = new int (29));
      cout << *y << "\n";

      a = st.getcnt ();
      cout << "Anzal: " << a << "\n";

      if (a != 3)
	errornum++;


      // hole die 29 runter
      y = st.pop ();
      cout << "pop " << *y << " ";
      if (*y != 29)
	errornum++;
      delete y;

      y = st.pop ();
      cout << *y << "\n";
      if (*y != 28)
	errornum++;
      delete y;

      cout << "Anzahl: " << (a = st.getcnt ()) << "\n";
      if (a != 1)
	errornum++;

      st.push (y = new int (17));
      cout << "push: " << *y << " ";
      st.push (y = new int (18));
      cout << *y << " ";
      st.push (y = new int (19));
      cout << *y << "\n";

      z = st.getcnt ();
      cout << "Anzahl: " << z << "\n";
      if (z != 4)
	errornum++;

      cout << "pop ";
      for (x = 0; x < z; x++)
	{
	  y = st.pop ();
	  cout << *y << " ";
	  delete y;
	}

      z = st.getcnt ();
      cout << "\nAnzahl: " << z << "\n";
      if (z != 0)
	errornum++;


      if (errornum)
	exit (-1);

      cout << "*** Error=" << errornum << " *** " << " Durchlauf: " << i
	<< " ***\n";

      // nice zu anderen Prozesen
      usleep (500);
    }


  return 0;

}
