// Sortierungsgeschwindigkeit testen

#include <stdio.h>

#include "../hash/hash.hh"

#include <unistd.h>
#include <time.h>


// Stringsort

// Maximaler Zahlenwert fr die Caracters
#define MAXLEN 70

char von, bis;



// Ausgaben
int verbose;

hstrsort *strsort;



// #########  Zufallsstrings ############

char
randchar (float von, float bis)
{
  return (char) (((float) rand () / (float) RAND_MAX) * (bis - von) + von);
}

char *
randomstr ()
{
  unsigned char len, x;
  char *str;

  len = randchar (2, 68);

  str = new char[len + 1];

  if (str)
    {
      for (x = 0; x < len; x++)
	str[x] = randchar (von, bis);

      str[len] = 0;
    }
  else
    {
      cout << "new randchar = NULL!";
    }
  return str;
}


void
initarray (unsigned int anz, char *a[])
{
  for (unsigned int x = 0; x < anz; x++)
    a[x] = randomstr ();
}


void
ausgabe (unsigned int anz, char *a[])
{
  for (unsigned int x = 0; x < anz; x++)
    cout << x + 1 << ": " << a[x] << endl;
}

// ########## Testen ##########################
bool
teststr (char *a, char *b)
{
  int x, min, lena, lenb;
  bool isgleich;

  isgleich = true;

  // a  <=  b
  lena = strlen (a);
  lenb = strlen (b);

  min = (lena < lenb) ? lena : lenb;

  for (x = 0; x < min; x++)
    {
      if (a[x] > b[x])
	{
	  return true;		// falsch
	}
      if (a[x] < b[x])
	{
	  // isok 
	  return false;
	}
    }

  // string 1 ist gleich string2 
  // jetzt zhlt die Lnge
  if (isgleich)
    {
      if (lena > lenb)
	{
	  return true;		// falsch
	}
    }

  // Lnge ist auch gleich
  return false;
}

bool
testesort (unsigned int anz, char *a[])
{

  anz--;
  for (unsigned int x = 0; x < anz; x++)
    {
      cout << "teste a: " << x + 1 << ": " << a[x] << endl;
      cout << "teste b: " << x + 2 << ": " << a[x + 1];

      if (teststr (a[x], a[x + 1]))
	{
	  cout << " grer!\n";
	  return 255;
	}
      else
	cout << " OK, <= !\n";
    }

  return false;
}

// ############ Mehrfachtests ############################

clock_t
exhsort (int l, unsigned short anz, char **a, char **&b)
{
  int x;
  clock_t ha, he, hd;

  hd = 0;

  for (x = 0; x < l; x++)
    {

      strsort = new hstrsort (anz);

      cerr << "new hstrsort ( " << anz << " );" << endl;

      ha = clock ();
      strsort->exsort ((const char **) a);
      he = clock ();

      hd += he - ha;

      if (x < l - 1)
	delete strsort;
    }

  // a freigeben
  for (x = 0; x < anz; x++)
    {
      delete[]a[x];
    }
  delete a;


  b = new char *[anz];
  memset (b, 0, sizeof (char *) * anz);

  for (x = 0; x < anz; x++)
    {
      b[x] = new char[MAXLEN + 1];
      memset (b[x], 0, sizeof (char) * MAXLEN + 1);
    }

  strsort->getall (b);

  return hd;
}

// teste sort
int
main (int argc, char *argv[])
{
  char **a, **b;
  int e, x, loops;
  int random;

  clock_t hd;

  FILE *rdev;

  unsigned short anz, anzeige;	// Anzahl der Zahlen

  anz = 0xff;
  verbose = false;
  e = 0;
  loops = anzeige = 10;

  von = '1';
  bis = 'Z';

  // lese das Argument #################
  if (argc < 2)
    {
    hilfe:
      cout << "Bitte geben Sie die Anzahl der Values an!\n";
      cout << "hsort [-vN|VN ] [-h|?] [-a N ] [-l N] \n";
      cout << "v = Verbose Anzeigeanzahl N\n";
      cout << "a = Anzahl N\n";
      cout << "l = Schleifen, wieoft wird sortiert\n";
      cout << "A = Char von z.B.: -Aa \n";
      cout << "B = Char bis z.B.: -Bz \n";
      return -1;
    }

  for (e = 1; e != 0;)
    {
      switch ((x = getopt (argc, argv, "A:B:v:V:a:b:l:h?")))
	{
	case 'A':
	  von = *optarg;
	  break;
	case 'B':
	  bis = *optarg;
	  break;
	case 'v':
	  verbose = true;
	  anzeige = atol (optarg);
	  break;
	case 'V':
	  verbose = 2;
	  anzeige = atol (optarg);
	  break;
	case 'h':
	case '?':
	  goto hilfe;
	  break;
	case 'a':
	  anz = atol (optarg);
	  break;
	case 'l':
	  loops = atol (optarg);
	  break;

	case -1:
	  e = 0;
	  break;
	}
    }

  rdev = NULL;
  rdev = fopen ("/dev/random", "r");

  if (rdev)
    {
      fread (&random, sizeof (int), 1, rdev);
      srand (random);
    }

  e = 0;
  a = new char *[anz];

  if (a)
    {
      if (verbose)
	cout << "Init Array, Anz=" << anz << endl;

      initarray (anz, a);


      if (verbose)
	{
	  cout << "Ausgabe der ersten Zahlen: \n";
	  ausgabe (anzeige, a);
	  cout << "Sortiere Hsort...\n";
	}


      hd = exhsort (loops, anz, a, b);
      // a ist freigegeben !!!     


      if (verbose)
	{
	  //cout << "Diff: " << hq << endl;
	  cout << "Ausgabe der ersten sortierten Zahlen: \n";
	  ausgabe (anzeige, b);
	}


      e = testesort (anzeige, b);
      cout << "Ergebniss:\n";
      cout << "Errors: " << e << " !\n";
      cout << "Zeit hsort: " << hd << endl;

    }
  else
    {
      cerr << "Konnte nicht gengend " << anz << " Integer mallocen!\n";
    }

  return e;
}
