/*
 * Test und Dokumentationsprogramm zur hash.h
 * 
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 *
 */

#include <unistd.h>
#include "hash.hh"


#define  ANZ  0x1fff
#define SCHLEIFEN 0xff
#define ZSLEEP 200



int erroranz;

typedef unsigned long unsl;

int
main (int argc, char *argv[])
{
  short a;
  short *p, x, y;
  long i, schleifen;
  errorenum e;

  larray < short *>*liste;

  laperror err;

  //    data        keystruct, hier nicht verwendet
  //xdhashshort < short *, short >hh;
  xdhashshort < short *, short >hh;

  erroranz = 0;

  // lese den Parameter ein
  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  usleep (ZSLEEP);


  // gehe die Schleifen durch
  for (i = 0; i < schleifen; i++)
    {

      cout << "\ninsert: " << ANZ << " items: ";

      for (a = 0; a < ANZ; a++)
	{
	  p = new short (-a - 1);

	  if ((e = hh.insert (a, p)))	// key , data
	    {
	      erroranz++;
	      err.str (e, "es wird nicht eingefgt");
	    }
	  else
	    cout << *p << " ";
	}
      cout << "\n*** Fehleranzahl (insert) ist:" << erroranz << "!, " <<
	"Schleife " << i << " Super! ***\n";
      if (erroranz)
	exit (-1);

      usleep (ZSLEEP);


      // man sollte die Eingefgten wiederfinden
      cout << "\nfinde: ";
      for (a = 0; a < ANZ; a++)
	{
	  hh.search (&p, a, &e);

	  if (p)
	    {
	      cout << *p << "  ";

	      // geht nicht bei null
	      if (-a - 1 != *p)
		erroranz++;

	      if (erroranz)
		{
		  cout << " Error Key=" << a << " Data=" << *p << endl;
		  exit (-1);
		}

	    }
	  else
	    erroranz++;
	}

      cout << "\n*** Fehleranzahl (finde) ist:" << erroranz << "!, " <<
	"Schleife " << i << " Super! ***\n";
      if (erroranz)
	exit (-1);


      cout << endl << "iteriere: ";


      // die Funktion getall gibt eine Liste zurck,
      // sollten Zeiger auf die Daten sein.
      liste = new larray < short *>(ANZ + 3);

      hh.getall (liste, &e);


      if (liste)
	{
	  x = *liste->getfirst ();

	  cout << "f: " << x << "\n";

	  // berprfe gleich mit der Suchfunktion
	  usleep (ZSLEEP);


	  while (liste->isnext ())
	    {
	      //y = *liste->getnext ();
	      liste->getnext (p);
	      y = *p;
	      cout << "l: " << y << " ";

	      if (y != x - 1)
		erroranz++;

	      if (erroranz)
		{
		  cout << " Error! " << " x=" << x << " y=" << y << endl;
		}

	      x = y;
	    }

	}
      else
	{
	  erroranz++;
	}

      cout << "\n*** Fehleranzahl (getfirst) ist:" << erroranz << "!, " <<
	"Schleife " << i << " Super! ***\n";
      if (erroranz)
	exit (-1);

      // die Liste wieder lschen, da keydata auch die Daten freigibt, sollte
      // man erst die Zeiger Nullen!
      liste->destroyall ();
      delete liste;

      cout << endl;


      cout << endl << "delete: ";
      e = NOOK;
      usleep (ZSLEEP);


      // Daten freigeben
      for (a = 0; a < ANZ; a++)
	{
	  hh.destroy (a, &e);

	  cout << a << " ";
	  if (e != ISOK)
	    {
	      erroranz++;
	    }
	}

      cout << "\n*** Fehleranzahl (delete) ist:" << erroranz << "!, " <<
	"Schleife " << i << " Super! ***\n";

      usleep (500);

      if (erroranz)
	{
	  exit (-1);
	}
    }


  return 0;
}
