/*
 * Autor:     Helmut Fahrion 
 * Email:     hefa@gmx.net
 * GPG-KeyID: 12622C98
 * Copyright: Mach was Du willst damit!
 */

#include <unistd.h>
#include "hash.hh"


#define  ANZ 0x1fff


int erroranz;


typedef unsigned long unsl;


#define ZSLEEP  100

int
main (int argc, char *argv[])
{
  long a;
  int *p, x, y, schleifen;
  long i;
  errorenum e;
  larray < int *>*liste;
  laperror err;

  //    data        keystruct, hier nicht verwendet
  xdhashint < int *, int >hh;

  // hole den Parameter
  if (argc < 2)
    {
      cout << "bitte geben Sie die Anzahl der Schleifen mit an!\n";
      return -1;
    }

  schleifen = 0;
  schleifen = atoi (argv[1]);

  if (schleifen <= 0)
    return -1;

  erroranz = 0;

  // gehe jetzt die Schleifen durch
  for (i = 0; i < schleifen; i++)
    {
      cout << "\ninsert: " << ANZ << " items: ";
      usleep (ZSLEEP);

      // fge einen Int ein
      for (a = 0; a < ANZ; a++)
	{
	  p = new int (-a - 1);

	  if ((e = hh.insert (a, p)))	// key , data
	    {
	      erroranz++;
	      err.str (e, "es wird nicht eingefgt");
	    }
	  else
	    cout << *p << " ";
	}
      cout << "\n*** Fehleranzahl ist:" << erroranz << "!, " << "Schleife " <<
	i << " Super! ***\n";
      if (erroranz)
	exit (-1);

      // teste ob diese Ints drinnen sind
      usleep (ZSLEEP);

      cout << "\nfinde: ";
      for (a = 0; a < ANZ; a++)
	{
	  hh.search (&p, a, &e);
	  if (p)
	    {
	      cout << *p << "  ";
	      // geht nicht bei null
	      if (-a - 1 != *p)
		erroranz++;

	      if (erroranz)
		{
		  cout << " Error Key=" << a << " Data=" << *p << endl;
		  exit (-1);
		}
	    }
	  else
	    erroranz++;
	}

      cout << "\n*** Fehleranzahl ist:" << erroranz << "!, " << "Schleife " <<
	i << " Super! ***\n";
      if (erroranz)
	exit (-1);


      cout << endl << "iteriere: ";


      // die Funktion getall gibt eine Liste zurck,
      // sollten Zeiger auf die Daten sein.
      liste = new larray < int *>(ANZ + 3);

      hh.getall (liste, &e);


      // Teste den Listeninhalt
      if (liste)
	{
	  x = *((int *) liste->getfirst ());

	  cout << "f: " << x << "\n";

	  // berprfe gleich mit der Suchfunktion
	  usleep (ZSLEEP);

	  while (liste->isnext ())
	    {
	      liste->getnext (p);
	      y = *p;
	      //y = *((int *) liste->getnext ());

	      cout << "l: " << y << " ";

	      if (y != x - 1)
		erroranz++;

	      if (erroranz)
		{
		  cout << " Error! " << " x=" << x << " y=" << y << endl;
		}
	      x = y;
	    }
	}
      else
	{
	  erroranz++;
	}

      cout << "\n*** Fehleranzahl ist:" << erroranz << "!, " << "Schleife " <<
	i << " Super! ***\n";
      if (erroranz)
	exit (-1);

      // Lsche die Liste wieder
      delete liste;
      cout << endl;

      cout << endl << "delete: ";
      e = NOOK;

      // lsche den Hash
      usleep (ZSLEEP);

      /*
         for (a = 0; a < ANZ; a++)
         {
         hh.destroy (a, &e);

         cout << a << " ";
         if (e != ISOK)
         {
         erroranz++;
         }
         }
       */

      hh.delall ();

      liste = new larray < int *>(ANZ + 3);

      hh.getall (liste, &e);


      // Teste den Listeninhalt
      if (liste)
	{

	  if ((p = (int *) liste->getfirst ()))

	    {

	      cout << "f: " << *p << "\n";

	      erroranz++;

	      // berprfe gleich mit der Suchfunktion
	      usleep (ZSLEEP);

	      while (liste->isnext ())
		{
		  liste->getnext (p);
		  y = *p;
		  //y = *((int *) liste->getnext ());
		  cout << "l: " << y << " ";

		  erroranz++;

		}
	    }
	}


      cout << "\n*** Ende: Fehleranzahl ist:" << erroranz << "!, " <<
	"Schleife " << i << " Super! ***\n";

      usleep (200);

      if (erroranz)
	{
	  exit (-1);
	}
    }

  return 0;
}
